/*
Descrio: Procedimento para atualizao do Inventrio Rotativo no Estoque

Criao:
29/08/2012 - Tarcsio Dias Pereira

@C:\Web_585\SQL\END_CONV\SQLSERVER\4800_ESTSTPS_ATUALIZA_INVENTARIO_ESTOQUE.SQL
*/
IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'ATUALIZA_INVENTARIO_ESTOQUE'
              AND TYPE = 'P'
              AND U.UID = O.UID
              AND U.NAME = USER)

DROP PROCEDURE ATUALIZA_INVENTARIO_ESTOQUE
GO

CREATE PROCEDURE ATUALIZA_INVENTARIO_ESTOQUE
   @P_EVOLEST        VARCHAR(01), 
   @P_CDFILIMOVI     VARCHAR(04),
   @P_CDFILIAL       VARCHAR(04),
   @P_CDOPERADOR     VARCHAR(12), 
   @P_DATAPROC       DATETIME,
   @P_INOPCAO        NUMERIC,
   @P_CDSERVFILI     VARCHAR(05),
   @P_CDTIPORETI     VARCHAR(02), 
   @P_CDCENTCUST     VARCHAR(04),
   @P_CDSETOR        VARCHAR(04),
   @P_RETIESTQ       VARCHAR(01),
   @P_CDALMOXARIFE   VARCHAR(MAX),
   @P_CDLOCALESTOQ   VARCHAR(MAX)
AS
   DECLARE @V_IDORDAJUINVE   VARCHAR(01);
   DECLARE @V_IDGERARETAJU   VARCHAR(01);
   DECLARE @V_IDUTILALMOX    VARCHAR(01);
   DECLARE @V_IDUTILLCESTQ   VARCHAR(01);
   DECLARE @V_IDUTILLOTE     VARCHAR(01);
   DECLARE @V_IDORDEMCLC     VARCHAR(01);
   DECLARE @V_IDCTRLESTQ     VARCHAR(01);
   DECLARE @V_CDPRODESTO     VARCHAR(10);
   DECLARE @V_VRFATOCONV     NUMERIC(15,5);
   DECLARE @V_CUSTOPROD      NUMERIC(15,5);
   DECLARE @V_QTINVROTA      NUMERIC(15,5);
   DECLARE @V_QTESTOQDIA     NUMERIC(15,5);
   DECLARE @V_ALMOXARIF      VARCHAR(06);
   DECLARE @V_LOCALEST       VARCHAR(06);
   DECLARE @V_NRAJUSTE       VARCHAR(10);
   DECLARE @V_NRSEQAJU       NUMERIC;
   DECLARE @V_DESCALMOX      VARCHAR(60);
   DECLARE @V_TIPOMOV        VARCHAR(01);
   DECLARE @V_NRLANCVER      VARCHAR(10);
   DECLARE @V_NRLANCESTRET   VARCHAR(10);
   DECLARE @V_NRRETIRADA     VARCHAR(10);
   DECLARE @V_NRCARDAPIO     VARCHAR(10);
   DECLARE @V_DTPOSESTDIA    DATETIME;
   DECLARE @V_CONTADOR       NUMERIC;
   DECLARE @V_NRIMPLANTA     VARCHAR(10);
   DECLARE @V_NRSEQIMP       NUMERIC;
   DECLARE @V_DTMOVI         DATETIME;
   DECLARE @V_NOVOCODIGO     VARCHAR(100);
   DECLARE @V_SEQUENCIAL     VARCHAR(20);
   /* VARIAVEIS DO CURSOR C_ATUAINVENTOK */
   DECLARE @V_INVCDFILIAL      VARCHAR(04);
   DECLARE @V_INVDTINVEROTA    DATETIME;
   DECLARE @V_INVCDALMOXARIFE  VARCHAR(06);
   DECLARE @V_INVCDLOCALESTOQ  VARCHAR(06);
   DECLARE @V_INVCDPRODUTO     VARCHAR(10);
   DECLARE @V_INVQTINVEROTA    NUMERIC(15,5);
   DECLARE @V_INVQTESTOQUE     NUMERIC(15,5);
   /* VARIAVEIS DO CURSOR C_ZERAEST */
   DECLARE @V_ZCDPRODUTO       VARCHAR(10);
   DECLARE @V_ZCDALMOXARIFE    VARCHAR(06);
   DECLARE @V_ZCDLOCALESTOQ    VARCHAR(06);
   DECLARE @V_ZNRLOTEESTQ      VARCHAR(20);
   DECLARE @V_ZNRSUBLOTE       VARCHAR(04);
   /* VARIAVEIS DO CURSOR C_MOVILOTE */
   DECLARE @V_MCDFILIAL        VARCHAR(04);
   DECLARE @V_MCDALMOXARIFE    VARCHAR(06);
   DECLARE @V_MCDLOCALESTOQ    VARCHAR(06);
   DECLARE @V_MNRLOTEESTQ      VARCHAR(20);
   DECLARE @V_MNRSUBLOTE       VARCHAR(04);
   DECLARE @V_MCDPRODUTO       VARCHAR(10);
   /* VARIAVEIS DO CURSOR C_ATUAINVLOTEOK */
   DECLARE @V_INVLTCDFILIAL      VARCHAR(04);
   DECLARE @V_INVLTDTINVELOTE    DATETIME;
   DECLARE @V_INVLTCDALMOXARIFE  VARCHAR(06);
   DECLARE @V_INVLTCDLOCALESTOQ  VARCHAR(06);
   DECLARE @V_INVLTCDPRODUTO     VARCHAR(10);
   DECLARE @V_INVLTNRLOTEESTQ    VARCHAR(20);
   DECLARE @V_INVLTNRSUBLOTE     VARCHAR(04);
   DECLARE @V_INVLTQTINVELOTE    NUMERIC(15,5);
   DECLARE @V_INVLTQTESTOLOTE    NUMERIC(15,5);

   DECLARE @V_QTLANCSAID NUMERIC;
   DECLARE @V_NRLANCIRREST VARCHAR(20);
   DECLARE @V_NRITEMIRREG NUMERIC;
   DECLARE @V_COUNTIRREG NUMERIC;

   /* VARIAVEIS DO CURSOR C_VERIFESTOQUE */
   DECLARE @C_VERIFESTOQUE_CDFILIAL     VARCHAR(04);
   DECLARE @C_VERIFESTOQUE_DTINVEROTA   DATETIME;
   DECLARE @C_VERIFESTOQUE_CDALMOXARIFE VARCHAR(06);;
   DECLARE @C_VERIFESTOQUE_CDLOCALESTOQ VARCHAR(06);
   DECLARE @C_VERIFESTOQUE_CDPRODUTO    VARCHAR(20);
   DECLARE @C_VERIFESTOQUE_QTINVEROTA   NUMERIC(15,5);
   DECLARE @C_VERIFESTOQUE_QTESTOQUE    NUMERIC(15,5);
   DECLARE @C_VERIFESTOQUE_NMPRODUTO    VARCHAR(100);
   DECLARE @C_VERIFESTOQUE_CDARVPROD    VARCHAR(100);

   /* VARIAVEIS DO CURSOR C_VERIFESTOQUELOTE */
   DECLARE @C_VERIFESTOQUELOTE_CDFILIAL VARCHAR(04);
   DECLARE @C_VERIFESTOQUELOTE_DTINVELOTE DATETIME;
   DECLARE @C_VERIFESTOQUELOTE_CDALMOXARIFE VARCHAR(06);
   DECLARE @C_VERIFESTOQUELOTE_CDLOCALESTOQ VARCHAR(06);
   DECLARE @C_VERIFESTOQUELOTE_CDPRODUTO VARCHAR(20);
   DECLARE @C_VERIFESTOQUELOTE_NRLOTEESTQ VARCHAR(20);
   DECLARE @C_VERIFESTOQUELOTE_NRSUBLOTE VARCHAR(04);
   DECLARE @C_VERIFESTOQUELOTE_QTINVELOTE NUMERIC(15, 5);
   DECLARE @C_VERIFESTOQUELOTE_QTESTOLOTE NUMERIC(15, 5);
   DECLARE @C_VERIFESTOQUELOTE_NMPRODUTO VARCHAR(10);
   DECLARE @C_VERIFESTOQUELOTE_CDARVPROD VARCHAR(20);
BEGIN
   SET @V_IDORDAJUINVE = NULL;
   SET @V_IDGERARETAJU = NULL;
   SET @V_IDUTILALMOX = NULL;
   SET @V_IDUTILLCESTQ = NULL;
   SET @V_IDUTILLOTE = NULL;
   SET @V_IDORDEMCLC = NULL;
   SET @V_IDCTRLESTQ = NULL;
   SET @V_CDPRODESTO = NULL;
   SET @V_VRFATOCONV = 0;
   SET @V_CUSTOPROD = 0;
   SET @V_QTINVROTA = 0;
   SET @V_QTESTOQDIA = 0;
   SET @V_ALMOXARIF = 'NOVO';
   SET @V_LOCALEST = 'NOVO';
   SET @V_NRAJUSTE = NULL;
   SET @V_NRSEQAJU = 0;
   SET @V_DESCALMOX = NULL;
   SET @V_TIPOMOV = NULL;
   SET @V_NRLANCVER = NULL;
   SET @V_NRLANCESTRET = NULL;
   SET @V_NRRETIRADA = NULL;
   SET @V_NRCARDAPIO = NULL;
   SET @V_DTPOSESTDIA = NULL;
   SET @V_CONTADOR = 0;
   SET @V_NRIMPLANTA = NULL;
   SET @V_NRSEQIMP = 0;
   SET @V_DTMOVI = NULL;

   SELECT @V_IDORDAJUINVE = IDORDAJUINVE, @V_IDGERARETAJU = IDGERARETAJU, @V_IDUTILALMOX = IDUTILALMOX, 
          @V_IDUTILLCESTQ = IDUTILLCESTQ, @V_IDUTILLOTE = IDUTILLOTE, @V_IDCTRLESTQ = IDCTRLESTQ
     FROM PARAMFILIAL
    WHERE CDFILIAL = @P_CDFILIAL;
       
   IF ((@V_IDORDAJUINVE IS NULL) OR (@V_IDORDAJUINVE = 'P')) BEGIN
      SET @V_IDORDEMCLC = 'O';
   END
   ELSE BEGIN
      SET @V_IDORDEMCLC = 'U';
   END;

   SET @V_NRAJUSTE = '';
   SET @V_NRLANCVER = '';
   SET @V_NRIMPLANTA = '';
   SET @V_NRLANCIRREST = '';
   SET @V_ALMOXARIF = 'NOVO';
   SET @V_LOCALEST = 'NOVO';

   SET @V_NRITEMIRREG =0;
   SET @V_COUNTIRREG =0;
   SET @V_QTLANCSAID =0;

   SET @V_NOVOCODIGO = 'TRAB_IRREG_EST' + @P_CDFILIAL;
   EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_NRLANCIRREST OUTPUT, @P_QTDE = 1;

   SET @V_NRLANCIRREST = SUBSTRING(@V_NRLANCIRREST, 11, 20);
   SET @V_COUNTIRREG = 0;

   IF (@V_IDUTILLOTE <> 'S') BEGIN
      IF @P_INOPCAO = 10 OR @P_INOPCAO = 12 BEGIN
         DECLARE C_VERIFESTOQUE CURSOR FOR
            SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.QTINVEROTA, I.QTESTOQUE,P.NMPRODUTO,P.CDARVPROD
              FROM INVEROTA I,PRODUTO P,
                   (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                      FROM INVEROTA
                     WHERE CDFILIAL = @P_CDFILIAL
                       AND ((CHARINDEX('_' + CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
                       AND ((CHARINDEX('_' + CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
                       AND DTINVEROTA < @P_DATAPROC
                     GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) X
             WHERE I.CDFILIAL = @P_CDFILIAL
               AND ((CHARINDEX('_' + I.CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
               AND ((CHARINDEX('_' + I.CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
               AND I.IDINVENTOK = 'N'
               AND I.CDFILIAL = X.CDFILIAL
               AND I.CDPRODUTO = X.CDPRODUTO
               AND I.CDALMOXARIFE = X.CDALMOXARIFE
               AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
               AND I.DTINVEROTA = X.DTINVEROTA
               AND I.CDPRODUTO  = P.CDPRODUTO
             ORDER BY I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ;
         OPEN C_VERIFESTOQUE;
         FETCH NEXT FROM C_VERIFESTOQUE INTO @C_VERIFESTOQUE_CDFILIAL,
                                              @C_VERIFESTOQUE_DTINVEROTA,
                                              @C_VERIFESTOQUE_CDALMOXARIFE,
                                              @C_VERIFESTOQUE_CDLOCALESTOQ,
                                              @C_VERIFESTOQUE_CDPRODUTO,
                                              @C_VERIFESTOQUE_QTINVEROTA,
                                              @C_VERIFESTOQUE_QTESTOQUE,
                                              @C_VERIFESTOQUE_NMPRODUTO,
                                              @C_VERIFESTOQUE_CDARVPROD;
         WHILE @@FETCH_STATUS = 0 BEGIN
            IF @V_IDORDEMCLC = 'O' AND @V_IDGERARETAJU = 'S' BEGIN
               SELECT @V_QTLANCSAID = ISNULL(SUM(A.QTLANCTOEST), 0)
                 FROM ITLANCTOEST A, PRODUTO B
                WHERE (A.CDFILIMOVI = @P_CDFILIMOVI)
                  AND (A.CDPRODUTO = @C_VERIFESTOQUE_CDPRODUTO)
                  AND (B.CDPRODUTO = A.CDPRODUTO)
                  AND (A.CDALMOXARIFE = @C_VERIFESTOQUE_CDALMOXARIFE)
                  AND (A.CDLOCALESTOQ = @C_VERIFESTOQUE_CDLOCALESTOQ)
                  AND (A.IDTIPOMOVI IN ('3','4'))
                  AND (A.DTLANCMOVI BETWEEN @P_DATAPROC - 1 AND GETDATE() + (SELECT CASE ISNULL(NRDIASSAIDPDFIL, '') WHEN ''
                                                                                   THEN
                                                                                      (SELECT NRDIASSAIDPD FROM PARAMESTOQUE)
                                                                                   ELSE
                                                                                      NRDIASSAIDPDFIL
                                                                                   END NRDIASSAIDA
                                                                        FROM PARAMFILIAL
                                                                       WHERE CDFILIAL = @P_CDFILIMOVI))
               GROUP BY A.CDFILIAL,A.CDPRODUTO, A.DTLANCMOVI,B.NMPRODUTO;
            END
            ELSE BEGIN
               SELECT @V_QTLANCSAID = ISNULL(SUM(A.QTLANCTOEST), 0)
                 FROM ITLANCTOEST A, PRODUTO B
                WHERE (A.CDFILIMOVI = @P_CDFILIMOVI)
                  AND (A.CDPRODUTO = @C_VERIFESTOQUE_CDPRODUTO)
                  AND (B.CDPRODUTO = A.CDPRODUTO)
                  AND (A.CDALMOXARIFE = @C_VERIFESTOQUE_CDALMOXARIFE)
                  AND (A.CDLOCALESTOQ = @C_VERIFESTOQUE_CDLOCALESTOQ)
                  AND (A.IDTIPOMOVI IN ('3','4'))
                  AND (A.DTLANCMOVI BETWEEN @P_DATAPROC AND GETDATE() + (SELECT CASE ISNULL(NRDIASSAIDPDFIL, '') WHEN ''
                                                                                   THEN
                                                                                      (SELECT NRDIASSAIDPD FROM PARAMESTOQUE)
                                                                                   ELSE
                                                                                      NRDIASSAIDPDFIL
                                                                                   END NRDIASSAIDA
                                                                        FROM PARAMFILIAL
                                                                       WHERE CDFILIAL = @P_CDFILIMOVI))
               GROUP BY A.CDFILIAL,A.CDPRODUTO, A.DTLANCMOVI,B.NMPRODUTO;
            END;

            IF @V_QTLANCSAID > @C_VERIFESTOQUE_QTINVEROTA BEGIN
               SET @V_NRITEMIRREG = @V_NRITEMIRREG +1;
               INSERT INTO TRAB_IRREG_EST(NRLANCIRREST,
                                          NRITEMIRREG,
                                          CDFILIAL,
                                          CDPRODUTO,
                                          NMPRODUTO,
                                          CDALMOXARIFE,
                                          CDLOCALESTOQ,
                                          QTINVEROTA,
                                          QTLANCSAID)
               VALUES (@V_NRLANCIRREST,
                       @V_NRITEMIRREG,
                       @C_VERIFESTOQUE_CDFILIAL,
                       @C_VERIFESTOQUE_CDPRODUTO,
                       @C_VERIFESTOQUE_NMPRODUTO,
                       @C_VERIFESTOQUE_CDALMOXARIFE,
                       @C_VERIFESTOQUE_CDLOCALESTOQ,
                       @C_VERIFESTOQUE_QTINVEROTA,
                       @V_QTLANCSAID);
               SET @V_COUNTIRREG = @V_COUNTIRREG + 1;
               COMMIT;
            END;

            FETCH NEXT FROM C_VERIFESTOQUE INTO @C_VERIFESTOQUE_CDFILIAL,
                                              @C_VERIFESTOQUE_DTINVEROTA,
                                              @C_VERIFESTOQUE_CDALMOXARIFE,
                                              @C_VERIFESTOQUE_CDLOCALESTOQ,
                                              @C_VERIFESTOQUE_CDPRODUTO,
                                              @C_VERIFESTOQUE_QTINVEROTA,
                                              @C_VERIFESTOQUE_QTESTOQUE,
                                              @C_VERIFESTOQUE_NMPRODUTO,
                                              @C_VERIFESTOQUE_CDARVPROD;
            IF (@V_COUNTIRREG  > 0) BEGIN
               RAISERROR(@V_NRLANCIRREST, 16, 1);
            END;
         END;
         CLOSE C_VERIFESTOQUE;
         DEALLOCATE C_VERIFESTOQUE;
      END;

      /* INVENTRIO ROTATIVO*/
      /* INCLUSO DE AJUSTE E DE RETIRADA */
      DECLARE C_ATUAINVENTOK CURSOR FOR
      SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.QTINVEROTA, I.QTESTOQUE
        FROM INVEROTA I, PRODUTO P,
             (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                FROM INVEROTA
               WHERE CDFILIAL = @P_CDFILIAL
                 AND ((CHARINDEX('_' + CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
                 AND ((CHARINDEX('_' + CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
                 AND DTINVEROTA < @P_DATAPROC
               GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) X
       WHERE I.CDFILIAL = @P_CDFILIAL
         AND ((CHARINDEX('_' + I.CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
         AND ((CHARINDEX('_' + I.CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
         AND I.IDINVENTOK = 'N'
         AND I.CDFILIAL = X.CDFILIAL
         AND I.CDPRODUTO = X.CDPRODUTO
         AND I.CDALMOXARIFE = X.CDALMOXARIFE
         AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
         AND I.DTINVEROTA = X.DTINVEROTA
         AND I.CDPRODUTO  = P.CDPRODUTO
       ORDER BY I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ;

       OPEN C_ATUAINVENTOK;
       FETCH NEXT FROM C_ATUAINVENTOK INTO @V_INVCDFILIAL, @V_INVDTINVEROTA, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ,
                                           @V_INVCDPRODUTO, @V_INVQTINVEROTA, @V_INVQTESTOQUE;

       WHILE (@@FETCH_STATUS = 0) BEGIN
          SELECT @V_CDPRODESTO = CDPRODESTO, @V_VRFATOCONV = VRFATOCONV
            FROM PRODUTO
           WHERE CDPRODUTO = @V_INVCDPRODUTO;

          SET @V_CUSTOPROD = TEKNISA.CUSTO_PRODUTO_LCEST(@V_INVCDFILIAL, @V_CDPRODESTO, 3, @P_DATAPROC, GETDATE(),
                                                         @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, ' ', ' ') * @V_VRFATOCONV;

          IF (@V_INVQTESTOQUE = 0) BEGIN
             SET @V_QTESTOQDIA = @V_INVQTESTOQUE;
          END
          ELSE BEGIN
             SET @V_QTESTOQDIA = @V_INVQTESTOQUE / @V_VRFATOCONV;
          END;

          IF (@V_VRFATOCONV = 1) BEGIN
             SET @V_QTINVROTA = @V_INVQTINVEROTA;
          END
          ELSE BEGIN
             SET @V_QTINVROTA = @V_INVQTINVEROTA * @V_VRFATOCONV;
          END;
          
          IF (@V_IDORDAJUINVE = 'U') BEGIN
             SET @V_DTPOSESTDIA = @V_INVDTINVEROTA;
          END
          ELSE BEGIN
             SET @V_DTPOSESTDIA = @V_INVDTINVEROTA - 1;
          END;
          
          IF (@V_CUSTOPROD > 0) BEGIN
             SET @V_TIPOMOV = '1';
             /* CASO HAJA UMA MUDANA DE ALMOXARIFADO OU LOCALIZAO, OU O NMERO DE ITENS DE LANAMENTOS ATINGIR SEU VALOR MXIMO, 
                SER INCLUDO UM NOVO AJUSTE */
             IF ((@V_ALMOXARIF <> @V_INVCDALMOXARIFE) OR (@V_LOCALEST <> @V_INVCDLOCALESTOQ) OR (@V_NRSEQAJU = 9999)) BEGIN
                IF (@V_NRAJUSTE IS NOT NULL) BEGIN
                   IF ((@P_INOPCAO = 3) AND ((@V_ALMOXARIF <> @V_INVCDALMOXARIFE) OR (@V_LOCALEST <> @V_INVCDLOCALESTOQ))) BEGIN
                     /* SE A OPO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
                        E QUE NO ESTO CADASTRADOS NO INVENTRIO, SERO ZERADOS */
                      DECLARE C_ZERAEST CURSOR FOR
                      SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
                        FROM POSESTDIA A,
                             (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                                FROM POSESTDIA
                               WHERE CDFILIAL = @P_CDFILIAL
                                 AND CDALMOXARIFE = @V_ALMOXARIF
                                 AND CDLOCALESTOQ = @V_LOCALEST
                                 AND DTPOSIESTQ < @V_DTMOVI
                               GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
                       WHERE A.CDFILIAL = @P_CDFILIAL
                         AND A.CDALMOXARIFE = @V_ALMOXARIF
                         AND A.CDLOCALESTOQ = @V_LOCALEST
                         AND A.CDFILIAL = X.CDFILIAL
                         AND A.CDPRODUTO = X.CDPRODUTO
                         AND A.CDALMOXARIFE = X.CDALMOXARIFE
                         AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                         AND A.NRLOTEESTQ = X.NRLOTEESTQ
                         AND A.NRSUBLOTE = X.NRSUBLOTE
                         AND A.DTPOSIESTQ = X.DTPOSIESTQ
                         AND A.QTESTOQDIA <> 0
                         AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO
                                           FROM INVEROTA I,
                                                (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                                                   FROM INVEROTA
                                                  WHERE CDFILIAL = @P_CDFILIAL
                                                    AND CDALMOXARIFE = @V_ALMOXARIF
                                                    AND CDLOCALESTOQ = @V_LOCALEST
                                                    AND DTINVEROTA < @V_DTMOVI
                                                  GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) B
                                          WHERE I.CDFILIAL = @P_CDFILIAL
                                            AND I.CDALMOXARIFE = @V_ALMOXARIF
                                            AND I.CDLOCALESTOQ = @V_LOCALEST
                                            AND I.CDFILIAL = B.CDFILIAL
                                            AND I.CDPRODUTO = B.CDPRODUTO
                                            AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                            AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                            AND I.DTINVEROTA = B.DTINVEROTA
                                            AND A.CDFILIAL = I.CDFILIAL
                                            AND A.CDPRODUTO = I.CDPRODUTO
                                            AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                            AND A.CDLOCALESTOQ = I.CDLOCALESTOQ);
                   
                      OPEN C_ZERAEST;
                      FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;

                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         IF (@V_NRSEQAJU = 9999) BEGIN
                            /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZAO ANTERIOR */
                            IF (@P_EVOLEST = 'S') BEGIN
                               DECLARE C_MOVILOTE CURSOR FOR
                               SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                 FROM MOVILOTE 
                                WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;
                             
                               OPEN C_MOVILOTE;
                               FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                             @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                             
                               WHILE (@@FETCH_STATUS = 0) BEGIN
                                  UPDATE ITLANCTOEST
                                     SET IDEVOLESTOQ = 'S'
                                   WHERE CDFILIAL = @P_CDFILIAL
                                     AND NRLANCESTQ = @V_NRAJUSTE
                                     AND CDPRODUTO = @V_MCDPRODUTO
                                     AND CDALMOXARIFE = @V_MCDALMOXARIFE
                                     AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                                     AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                                     AND NRSUBLOTE = @V_MNRSUBLOTE;
                                
                                  FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                                  @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               END;
                               CLOSE C_MOVILOTE;
                               DEALLOCATE C_MOVILOTE;
                             
                               EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
                            END
                            ELSE BEGIN
                               UPDATE ITLANCTOEST
                                  SET IDEVOLESTOQ = 'N'
                                WHERE CDFILIAL = @P_CDFILIAL
                                  AND NRLANCESTQ = @V_NRAJUSTE;
                            END;
                            SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                            SET @V_NRAJUSTE = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                            
                            INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                            VALUES (@P_CDFILIAL, @V_NRAJUSTE, @V_TIPOMOV, @V_DTMOVI, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);
                              
                            SET @V_NRSEQAJU = 0;
                         END;
                         
                         SET @V_NRSEQAJU = @V_NRSEQAJU + 1;
                         
                         INSERT INTO ITLANCTOEST
                         (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, 
                         CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                         VALUES
                         (@P_CDFILIAL, @V_NRAJUSTE, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_ZCDPRODUTO, 0, 0, @V_ZCDPRODUTO, 'N', @P_CDFILIMOVI, @V_ZCDALMOXARIFE, 
                         @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE, '1', 0, 0, @V_DTMOVI, 0, 0, @V_IDORDEMCLC);

                         UPDATE ETIQUETAPRODOL
                            SET IDSTATUSETIQ = 'I',
                                DSNOTAFISORIGET = 'INV '+CONVERT(VARCHAR, GETDATE(), 103)
                           FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                         AND E.NRLANCTONF  = I.NRLANCTONF
                                                                         AND E.NRSEQITPROD = I.NRSEQITPROD
                          WHERE I.CDFILIMOVI   = @P_CDFILIMOVI
                            AND I.CDPRODUTO    = @V_ZCDPRODUTO
                            AND I.CDALMOXARIFE = @V_ZCDALMOXARIFE
                            AND I.NRLOTEESTQ   = @V_ZNRLOTEESTQ
                            AND I.CDLOCALESTOQ = @V_ZCDLOCALESTOQ
                            AND I.NRSUBLOTE    = @V_ZNRSUBLOTE
                            AND E.IDSTATUSETIQ <> 'I';

                         FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;
                      END;
                      CLOSE C_ZERAEST;
                      DEALLOCATE C_ZERAEST;
                   END;
                   /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZAO ANTERIOR */
                   IF (@P_EVOLEST = 'S') BEGIN
                      DECLARE C_MOVILOTE CURSOR FOR
                      SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                        FROM MOVILOTE 
                       WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;
                             
                      OPEN C_MOVILOTE;
                      FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                      @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                             
                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         UPDATE ITLANCTOEST
                            SET IDEVOLESTOQ = 'S'
                          WHERE CDFILIAL = @P_CDFILIAL
                            AND NRLANCESTQ = @V_NRAJUSTE
                            AND CDPRODUTO = @V_MCDPRODUTO
                            AND CDALMOXARIFE = @V_MCDALMOXARIFE
                            AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                            AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                            AND NRSUBLOTE = @V_MNRSUBLOTE;
                                
                         FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                         @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                      END;
                      CLOSE C_MOVILOTE;
                      DEALLOCATE C_MOVILOTE;
                             
                      EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
                   END
                   ELSE BEGIN
                      UPDATE ITLANCTOEST
                         SET IDEVOLESTOQ = 'N'
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCESTQ = @V_NRAJUSTE;
                   END;
                END;
                SET @V_ALMOXARIF = @V_INVCDALMOXARIFE;
                SET @V_LOCALEST = @V_INVCDLOCALESTOQ;
                SET @V_DTMOVI   = @V_INVDTINVEROTA;
                
                SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL; 
                EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                SET @V_NRAJUSTE = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                
                SET @V_DESCALMOX = 'Ajuste para Inventrio Rotativo';
                IF (@V_IDUTILALMOX = 'S') BEGIN
                   SET @V_DESCALMOX = @V_DESCALMOX + ' - Almox. ' + @V_INVCDALMOXARIFE;
                   IF (@V_IDUTILLCESTQ = 'S') BEGIN
                      SET @V_DESCALMOX = @V_DESCALMOX + ' Local. ' + @V_INVCDLOCALESTOQ;
                   END;
                END;
                
                /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - AJUSTE */
                INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                VALUES (@V_INVCDFILIAL, @V_NRAJUSTE, @V_TIPOMOV, @V_INVDTINVEROTA, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);
                
                SET @V_NRSEQAJU = 0;
             END;
             SET @V_NRSEQAJU = @V_NRSEQAJU + 1;
             
             IF (@V_IDGERARETAJU = 'S') BEGIN
                /* SE EST PARAMETRIZADO PARA REALIZAR RETIRADA AO REALIZAR AJUSTE NO ESTOQUE */
                IF (@P_RETIESTQ <> 'S') BEGIN
                   /* SE A RETIRADA  POR SERVIO */
                   IF ((@P_CDSERVFILI IS NOT NULL) AND (@V_INVQTINVEROTA < @V_QTESTOQDIA)) BEGIN
                      /* SE O SERVIO FOI INFORMADO E SE A QUANTIDADE DO INVENTARIO  MENOR QUE A QUANTIDADE EM ESTOQUE */
                      IF ((@V_NRLANCVER IS NULL) OR (@V_NRLANCVER <> @V_NRAJUSTE)) BEGIN
                         /* VERIFICA SE HOUVE MUDANA DE LANAMENTO DE AJUSTE */
                         IF (@V_NRLANCVER IS NOT NULL) BEGIN
                            /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTAO ANTERIOR */
                            IF (@P_EVOLEST = 'S') BEGIN
                               DECLARE C_MOVILOTE CURSOR FOR
                               SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                 FROM MOVILOTE 
                                WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRLANCESTRET;
                             
                               OPEN C_MOVILOTE;
                               FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                               @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               
                               WHILE (@@FETCH_STATUS = 0) BEGIN
                                  UPDATE ITLANCTOEST
                                     SET IDEVOLESTOQ = 'S'
                                   WHERE CDFILIAL = @P_CDFILIAL
                                     AND NRLANCESTQ = @V_NRLANCESTRET
                                     AND CDPRODUTO = @V_MCDPRODUTO
                                     AND CDALMOXARIFE = @V_MCDALMOXARIFE
                                     AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                                     AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                                     AND NRSUBLOTE = @V_MNRSUBLOTE;
                                
                                  FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                                  @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               END;
                               CLOSE C_MOVILOTE;
                               DEALLOCATE C_MOVILOTE;
                             
                               EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRLANCESTRET;
                            END
                            ELSE BEGIN
                               UPDATE ITLANCTOEST
                                  SET IDEVOLESTOQ = 'N'
                                WHERE CDFILIAL = @P_CDFILIAL
                                  AND NRLANCESTQ = @V_NRLANCESTRET;
                            END;
                         END;
                         /* CARREGA AS INFORMAES DA RETIRADA, DO CARDAPIO E DA RETIRADA DE ESTOQUE REFERENTES AO AJUSTE INFORMADO */
                         SELECT @V_NRLANCESTRET = AR.NRLANCESTRET, @V_NRRETIRADA = RE.NRRETIRADA, @V_NRCARDAPIO = CD.NRCARDAPIO
                           FROM CARDADIA CD, RETIRADA RE, AJURELACRET AR
                          WHERE CD.NRCARDAPIO = RE.NRCARDAPIO
                            AND CD.CDFILIAL = RE.CDFILIAL
                            AND RE.NRLANCESTQ = AR.NRLANCESTRET
                            AND RE.CDFILANCESTQ = AR.CDFILIAL
                            AND AR.CDFILIALRET = @V_INVCDFILIAL
                            AND AR.NRLANCESTQ = @V_NRAJUSTE
                            AND AR.CDFILIAL = @V_INVCDFILIAL;
                            
                         IF ((@V_NRLANCESTRET IS NULL) AND (@V_NRRETIRADA IS NULL) AND (@V_NRCARDAPIO IS NULL)) BEGIN
                            /* CASO NO TENHA INFORMAES DE RETIRADA CADASTRADAS */
                            
                            /* LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                            SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                            SET @V_NRLANCESTRET = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                            
                            INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                            VALUES (@P_CDFILIAL, @V_NRLANCESTRET, '3', @V_DTPOSESTDIA, @P_CDFILIMOVI, @P_CDOPERADOR, 'Retirada para Ajuste : '+ @V_NRAJUSTE);
                            
                            /* CARDPIO */
                            /* VERIFICA A EXISTNCIA DE CARDAPIO */
                            SELECT @V_NRCARDAPIO = NRCARDAPIO
                              FROM CARDADIA
                             WHERE CDFILIAL = @V_INVCDFILIAL
                               AND CDSERVFILI = @P_CDSERVFILI
                               AND DTCARDAPIO = @V_DTPOSESTDIA;
                              
                            IF (@V_NRCARDAPIO IS NULL) BEGIN
                               /* SE NO EXISTIR CARDAPIO, SER INCLUIDO UM NOVO */
                               SET @V_NOVOCODIGO = 'CARDAPIO' + @P_CDFILIAL;
                               EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                               SET @V_NRCARDAPIO = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                           
                               INSERT INTO CARDADIA
                               (CDFILIAL, NRCARDAPIO, CDSERVFILI, CDOPERADOR, DTCARDAPIO, DTMESCARD)
                               VALUES
                               (@P_CDFILIAL, @V_NRCARDAPIO, @P_CDSERVFILI, @P_CDOPERADOR, @V_DTPOSESTDIA, CONVERT(DATETIME, '01/' + SUBSTRING(CONVERT(VARCHAR, @V_DTPOSESTDIA, 103), 4, 7), 103));
                            END;
                            /* RETIRADA */
                            SET @V_NOVOCODIGO = 'RETIRADA' + @P_CDFILIAL;
                            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                            SET @V_NRRETIRADA = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                              
                            INSERT INTO RETIRADA
                            (CDFILIAL, NRRETIRADA, NRCARDAPIO, DTRETIRADA, CDFILANCESTQ, NRLANCESTQ)
                            VALUES
                            (@P_CDFILIMOVI, @V_NRRETIRADA, @V_NRCARDAPIO, @V_DTPOSESTDIA, @P_CDFILIAL, @V_NRLANCESTRET);
                              
                            /* RELACIONAMENTO AJUSTE/RETIRADA */
                            INSERT INTO AJURELACRET
                            (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                            VALUES
                            (@P_CDFILIAL, @V_NRAJUSTE, @P_CDFILIAL, @V_NRLANCESTRET);
                         END;
                         
                         /* VERIFICA SE O LANAMENTO DE RETIRADA DE ESTOQUE POSSUI REGISTRO (A AVALIAR)*/
                         SELECT @V_CONTADOR = COUNT(*)
                           FROM ITLANCTOEST
                          WHERE CDFILIAL = @V_INVCDFILIAL
                            AND NRLANCESTQ = @V_NRLANCESTRET;
                           
                         IF @V_CONTADOR > 0 BEGIN
                            /* CASO EXISTA REGISTROS, ESSES REGISTROS SERO DELETADOS (A AVALIAR) */
                            DELETE FROM ITEMRETI
                             WHERE CDFILIAL = @V_INVCDFILIAL
                               AND NRRETIRADA = @V_NRRETIRADA
                               AND NRCARDAPIO = @V_NRCARDAPIO;
                              
                            DELETE FROM ITLANCTOEST
                             WHERE CDFILIAL = @V_INVCDFILIAL
                               AND NRLANCESTQ = @V_NRLANCESTRET;
                         END;
                         
                         SET @V_NRLANCVER = @V_NRAJUSTE;
                      END;
                      /* NESTE LOCAL DA TELA TEM UMA VERIFICAO NA TELA DE INVENTRIO QUE, CASO O LANAMENTO DE ESTOQUE - RETIRADA TENHA 
                         ALGUM ITEM CADASTRADO NAQUELA POSIO DE ITEM, SER DELETADO PARA INSERIR UM NOVO REGISTRO NESTA POSIO (A VERIFICAR) */
                        
                      /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                      INSERT INTO ITLANCTOEST
                      (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, 
                      QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, 
                      IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO)
                      VALUES
                      (@V_INVCDFILIAL, @V_NRLANCESTRET, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVCDPRODUTO, (@V_QTESTOQDIA - @V_INVQTINVEROTA),
                      (@V_QTESTOQDIA - @V_INVQTINVEROTA), @V_CDPRODESTO, @P_CDFILIMOVI, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, ' ', ' ', '3',
                      'N', '9', @P_CDTIPORETI, @V_CUSTOPROD, ((@V_QTESTOQDIA - @V_INVQTINVEROTA) * @V_CUSTOPROD));
                        
                      /* INSERE O ITEM DE RETIRADA */
                      INSERT INTO ITEMRETI
                      (CDFILIAL, NRRETIRADA, NRCARDAPIO, NRSEQUITRETI, CDPRODUTO,
                      QTRETIRADA, CDFIITLANEST, NRLANCESTQ, NRSEQUITEM, CDTIPORETI)
                      VALUES
                      (@P_CDFILIMOVI, @V_NRRETIRADA, @V_NRCARDAPIO, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVCDPRODUTO,
                      (@V_QTESTOQDIA - @V_INVQTINVEROTA), @V_INVCDFILIAL, @V_NRLANCESTRET, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @P_CDTIPORETI);
                   END;
                END
                ELSE BEGIN
                   IF (@V_INVQTINVEROTA < @V_QTESTOQDIA) BEGIN
                      IF ((@V_NRLANCVER IS NULL) OR (@V_NRLANCVER <> @V_NRAJUSTE)) BEGIN
                         /* SE HOUVE MUDANA DO AJUSTE */
                         IF (@V_NRLANCVER IS NOT NULL) BEGIN
                            /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTAO ANTERIOR */
                            IF (@P_EVOLEST = 'S') BEGIN
                               DECLARE C_MOVILOTE CURSOR FOR
                               SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                 FROM MOVILOTE 
                                WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRLANCESTRET;
                             
                               OPEN C_MOVILOTE;
                               FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                               @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               
                               WHILE (@@FETCH_STATUS = 0) BEGIN
                                  UPDATE ITLANCTOEST
                                     SET IDEVOLESTOQ = 'S'
                                   WHERE CDFILIAL = @P_CDFILIAL
                                     AND NRLANCESTQ = @V_NRLANCESTRET
                                     AND CDPRODUTO = @V_MCDPRODUTO
                                     AND CDALMOXARIFE = @V_MCDALMOXARIFE
                                     AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                                     AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                                     AND NRSUBLOTE = @V_MNRSUBLOTE;
                                
                                  FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                                  @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               END;
                               CLOSE C_MOVILOTE;
                               DEALLOCATE C_MOVILOTE;
                             
                               EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRLANCESTRET;
                            END
                            ELSE BEGIN
                               UPDATE ITLANCTOEST
                                  SET IDEVOLESTOQ = 'N'
                                WHERE CDFILIAL = @P_CDFILIAL
                                  AND NRLANCESTQ = @V_NRLANCESTRET;
                            END;
                         END;
                           
                         /* LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                         SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                         EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                         SET @V_NRLANCESTRET = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                         
                         INSERT INTO LANCTOESTOQ
                         (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, CDOPERADOR, CDFILIMOVI)
                         VALUES
                         (@V_INVCDFILIAL, @V_NRLANCESTRET, '3', @V_DTPOSESTDIA, 'Retirada para Ajuste', @P_CDOPERADOR, @P_CDFILIMOVI);
                           
                         /* RETIRADA DE ESTOQUE */
                         SET @V_NOVOCODIGO = 'RETIESTO' + @P_CDFILIAL;
                         EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                         SET @V_NRRETIRADA = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                           
                         INSERT INTO RETIRADAESTO
                         (CDFILIAL, NRRETEST, DTRETEST, DSRETEST, CDFILIALLAN, NRLANCESTQ, CDSETOR, CDCENTCUST, NRORDPROD, NRREQUESTO)
                         VALUES
                         (@P_CDFILIMOVI, @V_NRRETIRADA, @V_DTPOSESTDIA, 'Retirada para Ajuste', @V_INVCDFILIAL, @V_NRLANCESTRET, @P_CDSETOR, @P_CDCENTCUST, NULL, NULL);
                           
                         /* RELACIONAMENTO AJUSTE/RETIRADA */
                         INSERT INTO AJURELACRET
                         (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                         VALUES
                         (@V_INVCDFILIAL, @V_NRAJUSTE, @V_INVCDFILIAL, @V_NRLANCESTRET);
                           
                         SET @V_NRLANCVER = @V_NRAJUSTE;
                      END;
                      
                      /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                      INSERT INTO ITLANCTOEST
                      (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, 
                      QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, 
                      IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO, CDCENTCUST)
                      VALUES
                      (@V_INVCDFILIAL, @V_NRLANCESTRET, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVCDPRODUTO, (@V_QTESTOQDIA - @V_INVQTINVEROTA),
                      (@V_QTESTOQDIA - @V_INVQTINVEROTA), @V_CDPRODESTO, @P_CDFILIMOVI, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, ' ', ' ', '3',
                      'N', '9', @P_CDTIPORETI, @V_CUSTOPROD, ((@V_QTESTOQDIA - @V_INVQTINVEROTA) * @V_CUSTOPROD), @P_CDCENTCUST);
                   END;
                END;
             END;
             
             /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - AJUSTE */
             INSERT INTO ITLANCTOEST
             (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
             CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
             NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
             VRTOTLANCTO, IDORDEMCLC)
             VALUES
             (@V_INVCDFILIAL, @V_NRAJUSTE, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVCDPRODUTO, @V_QTINVROTA, @V_INVQTINVEROTA,
             @V_CDPRODESTO, 'N', @P_CDFILIMOVI, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, ' ', ' ', @V_TIPOMOV, @V_CUSTOPROD, @V_CUSTOPROD, 
             @V_INVDTINVEROTA, (@V_CUSTOPROD * @V_VRFATOCONV), (@V_CUSTOPROD * @V_INVQTINVEROTA), @V_IDORDEMCLC);
               
             /* ATUALIZA O INVENTRIO DO PRODUTO */
             UPDATE INVEROTA
                SET IDINVENTOK = 'S'
              WHERE CDFILIAL = @V_INVCDFILIAL
                AND DTINVEROTA = @V_INVDTINVEROTA
                AND CDALMOXARIFE = @V_INVCDALMOXARIFE
                AND CDLOCALESTOQ = @V_INVCDLOCALESTOQ
                AND CDPRODUTO = @V_INVCDPRODUTO;
          END;
          
          IF (@V_IDCTRLESTQ <> 'N') BEGIN
             /* ATUALIZA REGISTRO DE PRODUTOS POR LOCAL DE ESTOQUE, SE A FILIAL CONTROLA ESTOQUE */
             INSERT INTO PRODLCESTOQ
             (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
             (SELECT @V_INVCDFILIAL, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, @V_CDPRODESTO
                FROM PRODFILI
               WHERE CDFILIAL = @V_INVCDFILIAL
                 AND CDPRODUTO = @V_CDPRODESTO
                 AND ISNULL(IDCNTRESTOQ, 'S') <> 'N'
                 AND NOT EXISTS(SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
                                  FROM PRODLCESTOQ
                                 WHERE CDFILIAL = @V_INVCDFILIAL
                                   AND CDALMOXARIFE = @V_INVCDALMOXARIFE
                                   AND CDLOCALESTOQ = @V_INVCDLOCALESTOQ
                                   AND CDPRODUTO = @V_CDPRODESTO));
          END;
          
          FETCH NEXT FROM C_ATUAINVENTOK INTO @V_INVCDFILIAL, @V_INVDTINVEROTA, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ,
                                              @V_INVCDPRODUTO, @V_INVQTINVEROTA, @V_INVQTESTOQUE;
       END;
       CLOSE C_ATUAINVENTOK;
       DEALLOCATE C_ATUAINVENTOK;
       
       IF (@V_NRAJUSTE IS NOT NULL) BEGIN
          IF (@P_INOPCAO = 3) BEGIN
             /* SE A OPO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
                E QUE NO ESTO CADASTRADOS NO INVENTRIO, SERO ZERADOS */
             DECLARE C_ZERAEST CURSOR FOR
             SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
               FROM POSESTDIA A,
                    (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                       FROM POSESTDIA
                      WHERE CDFILIAL = @P_CDFILIAL
                        AND CDALMOXARIFE = @V_ALMOXARIF
                        AND CDLOCALESTOQ = @V_LOCALEST
                        AND DTPOSIESTQ < @V_DTMOVI
                      GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
              WHERE A.CDFILIAL = @P_CDFILIAL
                AND A.CDALMOXARIFE = @V_ALMOXARIF
                AND A.CDLOCALESTOQ = @V_LOCALEST
                AND A.CDFILIAL = X.CDFILIAL
                AND A.CDPRODUTO = X.CDPRODUTO
                AND A.CDALMOXARIFE = X.CDALMOXARIFE
                AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                AND A.NRLOTEESTQ = X.NRLOTEESTQ
                AND A.NRSUBLOTE = X.NRSUBLOTE
                AND A.DTPOSIESTQ = X.DTPOSIESTQ
                AND A.QTESTOQDIA <> 0
                AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO
                                  FROM INVEROTA I,
                                       (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                                          FROM INVEROTA
                                         WHERE CDFILIAL = @P_CDFILIAL
                                           AND CDALMOXARIFE = @V_ALMOXARIF
                                           AND CDLOCALESTOQ = @V_LOCALEST
                                           AND DTINVEROTA < @V_DTMOVI
                                         GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) B
                                 WHERE I.CDFILIAL = @P_CDFILIAL
                                   AND I.CDALMOXARIFE = @V_ALMOXARIF
                                   AND I.CDLOCALESTOQ = @V_LOCALEST
                                   AND I.CDFILIAL = B.CDFILIAL
                                   AND I.CDPRODUTO = B.CDPRODUTO
                                   AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                   AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                   AND I.DTINVEROTA = B.DTINVEROTA
                                   AND A.CDFILIAL = I.CDFILIAL
                                   AND A.CDPRODUTO = I.CDPRODUTO
                                   AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                   AND A.CDLOCALESTOQ = I.CDLOCALESTOQ);
                   
             OPEN C_ZERAEST;
             FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;
                   
             WHILE (@@FETCH_STATUS = 0) BEGIN
                IF (@V_NRSEQAJU = 9999) BEGIN
                   /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZAO ANTERIOR */
                   IF (@P_EVOLEST = 'S') BEGIN
                      DECLARE C_MOVILOTE CURSOR FOR
                      SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                        FROM MOVILOTE 
                       WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;
                      
                      OPEN C_MOVILOTE;
                      FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                      @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                             
                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         UPDATE ITLANCTOEST
                            SET IDEVOLESTOQ = 'S'
                          WHERE CDFILIAL = @P_CDFILIAL
                            AND NRLANCESTQ = @V_NRAJUSTE
                            AND CDPRODUTO = @V_MCDPRODUTO
                            AND CDALMOXARIFE = @V_MCDALMOXARIFE
                            AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                            AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                            AND NRSUBLOTE = @V_MNRSUBLOTE;
                         
                         FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                         @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                      END;
                      CLOSE C_MOVILOTE;
                      DEALLOCATE C_MOVILOTE;
                      
                      EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
                   END
                   ELSE BEGIN
                      UPDATE ITLANCTOEST
                         SET IDEVOLESTOQ = 'N'
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCESTQ = @V_NRAJUSTE;
                   END;
                   SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                   EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                   SET @V_NRAJUSTE = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                   
                   INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                   VALUES (@P_CDFILIAL, @V_NRAJUSTE, @V_TIPOMOV, @V_DTMOVI, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);

                   SET @V_NRSEQAJU = 0;
                END;
                
                SET @V_NRSEQAJU = @V_NRSEQAJU + 1;
                
                INSERT INTO ITLANCTOEST
                (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, 
                CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                VALUES
                (@P_CDFILIAL, @V_NRAJUSTE, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_ZCDPRODUTO, 0, 0, @V_ZCDPRODUTO, 'N', @P_CDFILIMOVI, @V_ZCDALMOXARIFE, 
                @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE, '1', 0, 0, @V_DTMOVI, 0, 0, @V_IDORDEMCLC);

                UPDATE ETIQUETAPRODOL
                   SET IDSTATUSETIQ = 'I',
                       DSNOTAFISORIGET = 'INV '+CONVERT(VARCHAR, GETDATE(), 103)
                  FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                AND E.NRLANCTONF  = I.NRLANCTONF
                                                                AND E.NRSEQITPROD = I.NRSEQITPROD
                 WHERE I.CDFILIMOVI   = @P_CDFILIMOVI
                   AND I.CDPRODUTO    = @V_ZCDPRODUTO
                   AND I.CDALMOXARIFE = @V_ZCDALMOXARIFE
                   AND I.NRLOTEESTQ   = @V_ZNRLOTEESTQ
                   AND I.CDLOCALESTOQ = @V_ZCDLOCALESTOQ
                   AND I.NRSUBLOTE    = @V_ZNRSUBLOTE
                   AND E.IDSTATUSETIQ <> 'I';
                
                FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;
             END;
             CLOSE C_ZERAEST;
             DEALLOCATE C_ZERAEST;
          END;
          /* ATUALIZA A ULTIMA MOVIMENTAO DE AJUSTE E MOVIMENTAO DE RETIRADA NO ESTOQUE */
          IF (@P_EVOLEST = 'S') BEGIN
             DECLARE C_MOVILOTE CURSOR FOR
             SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
               FROM MOVILOTE 
              WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;
             
             OPEN C_MOVILOTE;
             FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                             @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                             
             WHILE (@@FETCH_STATUS = 0) BEGIN
                UPDATE ITLANCTOEST
                   SET IDEVOLESTOQ = 'S'
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCESTQ = @V_NRAJUSTE
                   AND CDPRODUTO = @V_MCDPRODUTO
                   AND CDALMOXARIFE = @V_MCDALMOXARIFE
                   AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                   AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                   AND NRSUBLOTE = @V_MNRSUBLOTE;
                
                FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
             END;
             CLOSE C_MOVILOTE;
             DEALLOCATE C_MOVILOTE;
             
             EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
             
             IF (@V_IDGERARETAJU = 'S') BEGIN
                DECLARE C_MOVILOTE CURSOR FOR
                SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                  FROM MOVILOTE 
                 WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRLANCESTRET;
                
                OPEN C_MOVILOTE;
                FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                
                WHILE (@@FETCH_STATUS = 0) BEGIN
                   UPDATE ITLANCTOEST
                      SET IDEVOLESTOQ = 'S'
                    WHERE CDFILIAL = @P_CDFILIAL
                      AND NRLANCESTQ = @V_NRLANCESTRET
                      AND CDPRODUTO = @V_MCDPRODUTO
                      AND CDALMOXARIFE = @V_MCDALMOXARIFE
                      AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                      AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                      AND NRSUBLOTE = @V_MNRSUBLOTE;
                   
                   FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                   @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                END;
                CLOSE C_MOVILOTE;
                DEALLOCATE C_MOVILOTE;
                
                EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRLANCESTRET;
             END;
          END
          ELSE BEGIN
             UPDATE ITLANCTOEST
                SET IDEVOLESTOQ = 'N'
              WHERE CDFILIAL = @P_CDFILIAL
                AND NRLANCESTQ = @V_NRAJUSTE;
             IF (@V_IDGERARETAJU = 'S') BEGIN
                UPDATE ITLANCTOEST
                   SET IDEVOLESTOQ = 'N'
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCESTQ = @V_NRLANCESTRET;
             END;
          END;
       END;
       
       /*    INCLUSO DE IMPLANTAO DE ESTOQUE     */
       SET @V_ALMOXARIF = 'NOVO';
       SET @V_LOCALEST  = 'NOVO';
       
       DECLARE C_ATUAINVENTOK CURSOR FOR
       SELECT I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.QTINVEROTA, I.QTESTOQUE
         FROM INVEROTA I,
              (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, MAX(DTINVEROTA) AS DTINVEROTA
                 FROM INVEROTA
                WHERE CDFILIAL = @P_CDFILIAL
                  AND ((CHARINDEX('_' + CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
                  AND ((CHARINDEX('_' + CDALMOXARIFE + CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
                  AND DTINVEROTA < @P_DATAPROC
                GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ) X
        WHERE I.CDFILIAL = @P_CDFILIAL
          AND ((CHARINDEX('_' + I.CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
          AND ((CHARINDEX('_' + I.CDALMOXARIFE + I.CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
          AND I.IDINVENTOK = 'N'
          AND I.CDFILIAL = X.CDFILIAL
          AND I.CDPRODUTO = X.CDPRODUTO
          AND I.CDALMOXARIFE = X.CDALMOXARIFE
          AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
          AND I.DTINVEROTA = X.DTINVEROTA
        ORDER BY I.CDFILIAL, I.DTINVEROTA, I.CDALMOXARIFE, I.CDLOCALESTOQ;

       OPEN C_ATUAINVENTOK;
       FETCH NEXT FROM C_ATUAINVENTOK INTO @V_INVCDFILIAL, @V_INVDTINVEROTA, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ,
                                           @V_INVCDPRODUTO, @V_INVQTINVEROTA, @V_INVQTESTOQUE;
       
       WHILE (@@FETCH_STATUS = 0) BEGIN
          SELECT @V_CDPRODESTO = CDPRODESTO, @V_VRFATOCONV = VRFATOCONV
            FROM PRODUTO
           WHERE CDPRODUTO = @V_INVCDPRODUTO;
          
          SET @V_CUSTOPROD = TEKNISA.CUSTO_PRODUTO_LCEST(@V_INVCDFILIAL, @V_CDPRODESTO, 3, @P_DATAPROC, GETDATE(), 
                                                         @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, ' ', ' ') * @V_VRFATOCONV;
          
          IF (@V_INVQTESTOQUE = 0) BEGIN
             SET @V_QTESTOQDIA = @V_INVQTESTOQUE;
          END
          ELSE BEGIN
             SET @V_QTESTOQDIA = @V_INVQTESTOQUE / @V_VRFATOCONV;
          END;
          
          IF (@V_VRFATOCONV = 1) BEGIN
             SET @V_QTINVROTA = @V_INVQTINVEROTA;
          END
          ELSE BEGIN
             SET @V_QTINVROTA = @V_INVQTINVEROTA * @V_VRFATOCONV;
          END;
          
          IF (@V_IDORDAJUINVE = 'U') BEGIN
             SET @V_DTPOSESTDIA = @V_INVDTINVEROTA;
          END
          ELSE BEGIN
             SET @V_DTPOSESTDIA = @V_INVDTINVEROTA - 1;
          END;
          
          SET @V_TIPOMOV = '0';
          
          IF ((@V_ALMOXARIF <> @V_INVCDALMOXARIFE) OR (@V_LOCALEST <> @V_INVCDLOCALESTOQ) OR (@V_NRSEQIMP = 9999)) BEGIN
             SET @V_ALMOXARIF = @V_INVCDALMOXARIFE;
             SET @V_LOCALEST = @V_INVCDLOCALESTOQ;
             
             IF (@V_NRIMPLANTA IS NOT NULL) BEGIN
                IF (@P_EVOLEST = 'S') BEGIN
                   DECLARE C_MOVILOTE CURSOR FOR
                   SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                     FROM MOVILOTE 
                    WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRIMPLANTA;
                   
                   OPEN C_MOVILOTE;
                   FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                   @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               
                   WHILE (@@FETCH_STATUS = 0) BEGIN
                      UPDATE ITLANCTOEST
                         SET IDEVOLESTOQ = 'S'
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCESTQ = @V_NRIMPLANTA
                         AND CDPRODUTO = @V_MCDPRODUTO
                         AND CDALMOXARIFE = @V_MCDALMOXARIFE
                         AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                         AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                         AND NRSUBLOTE = @V_MNRSUBLOTE;
                      
                      FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                      @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                   END;
                   CLOSE C_MOVILOTE;
                   DEALLOCATE C_MOVILOTE;
                   
                   EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRIMPLANTA;
                END
                ELSE BEGIN
                   UPDATE ITLANCTOEST
                      SET IDEVOLESTOQ = 'N'
                    WHERE CDFILIAL = @P_CDFILIAL
                      AND NRLANCESTQ = @V_NRIMPLANTA;
                END;
             END;
             
             SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
             EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
             SET @V_NRIMPLANTA = SUBSTRING(@V_SEQUENCIAL, 11, 20);
             
             SET @V_DESCALMOX = 'Implantao para Inventrio Rotativo';
             IF (@V_IDUTILALMOX = 'S') BEGIN
                SET @V_DESCALMOX = @V_DESCALMOX + ' - Almox. ' + @V_INVCDALMOXARIFE;
                  IF (@V_IDUTILLCESTQ = 'S') BEGIN
                     SET @V_DESCALMOX = @V_DESCALMOX + ' Local. ' + @V_INVCDLOCALESTOQ;
                  END;
             END;
             
             /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - IMPLANTAO */
             INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
             VALUES (@V_INVCDFILIAL, @V_NRIMPLANTA, @V_TIPOMOV, @V_INVDTINVEROTA, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);
             
             SET @V_NRSEQIMP = 0;
          END;
          
          SET @V_NRSEQIMP = @V_NRSEQIMP + 1;
          
          /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - IMPLANTAO */
          INSERT INTO ITLANCTOEST
          (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
          CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
          NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
          VRTOTLANCTO, IDORDEMCLC)
          VALUES
          (@V_INVCDFILIAL, @V_NRIMPLANTA, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQIMP),4), @V_INVCDPRODUTO, @V_QTINVROTA, @V_INVQTINVEROTA,
          @V_CDPRODESTO, 'N', @P_CDFILIMOVI, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ, ' ', ' ', @V_TIPOMOV, @V_CUSTOPROD, @V_CUSTOPROD, 
          @V_INVDTINVEROTA, (@V_CUSTOPROD * @V_VRFATOCONV), (@V_CUSTOPROD * @V_INVQTINVEROTA), @V_IDORDEMCLC);
          
          /* ATUALIZA O INVENTRIO DO PRODUTO */
          UPDATE INVEROTA
             SET IDINVENTOK = 'S'
           WHERE CDFILIAL = @V_INVCDFILIAL
             AND DTINVEROTA = @V_INVDTINVEROTA
             AND CDALMOXARIFE = @V_INVCDALMOXARIFE
             AND CDLOCALESTOQ = @V_INVCDLOCALESTOQ
             AND CDPRODUTO = @V_INVCDPRODUTO;
          
          FETCH NEXT FROM C_ATUAINVENTOK INTO @V_INVCDFILIAL, @V_INVDTINVEROTA, @V_INVCDALMOXARIFE, @V_INVCDLOCALESTOQ,
                                              @V_INVCDPRODUTO, @V_INVQTINVEROTA, @V_INVQTESTOQUE;
       END;
       CLOSE C_ATUAINVENTOK;
       DEALLOCATE C_ATUAINVENTOK;
       
       IF (@V_NRIMPLANTA IS NOT NULL) BEGIN
          IF (@P_EVOLEST = 'S') BEGIN
             DECLARE C_MOVILOTE CURSOR FOR
             SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
               FROM MOVILOTE 
              WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRIMPLANTA;
             
             OPEN C_MOVILOTE;
             FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                             @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
             
             WHILE (@@FETCH_STATUS = 0) BEGIN
                UPDATE ITLANCTOEST
                   SET IDEVOLESTOQ = 'S'
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCESTQ = @V_NRIMPLANTA
                   AND CDPRODUTO = @V_MCDPRODUTO
                   AND CDALMOXARIFE = @V_MCDALMOXARIFE
                   AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                   AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                   AND NRSUBLOTE = @V_MNRSUBLOTE;
                
                FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
             END;
             CLOSE C_MOVILOTE;
             DEALLOCATE C_MOVILOTE;

             EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRIMPLANTA;
          END
          ELSE BEGIN
             UPDATE ITLANCTOEST
                SET IDEVOLESTOQ = 'N'
              WHERE CDFILIAL = @P_CDFILIAL
                AND NRLANCESTQ = @V_NRIMPLANTA;
          END;
       END;
   END
   ELSE BEGIN
      IF @P_INOPCAO = 10 OR @P_INOPCAO = 12 BEGIN
         DECLARE C_VERIFESTOQUELOTE CURSOR FOR
          SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE, I.QTINVELOTE, I.QTESTOLOTE,P.NMPRODUTO,P.CDARVPROD
           FROM INVEROTALOTE I,PRODUTO P,
                (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                   FROM INVEROTALOTE
                  WHERE CDFILIAL = @P_CDFILIAL
                    AND ((CHARINDEX('_' + CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
                    AND ((CHARINDEX('_' + CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
                    AND DTINVELOTE < @P_DATAPROC
                  GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
          WHERE I.CDFILIAL = @P_CDFILIAL
            AND ((CHARINDEX('_' + I.CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
            AND ((CHARINDEX('_' + I.CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
            AND I.IDINVLOTEOK = 'N'
            AND I.CDFILIAL = X.CDFILIAL
            AND I.CDPRODUTO = X.CDPRODUTO
            AND I.CDALMOXARIFE = X.CDALMOXARIFE
            AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
            AND I.NRLOTEESTQ = X.NRLOTEESTQ
            AND I.NRSUBLOTE = X.NRSUBLOTE
            and I.DTINVELOTE = X.DTINVELOTE
            AND I.CDPRODUTO  = P.CDPRODUTO
          ORDER BY I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ;
         OPEN C_VERIFESTOQUELOTE;
         FETCH NEXT FROM C_VERIFESTOQUELOTE INTO @C_VERIFESTOQUELOTE_CDFILIAL,
                                                 @C_VERIFESTOQUELOTE_DTINVELOTE,
                                                 @C_VERIFESTOQUELOTE_CDALMOXARIFE,
                                                 @C_VERIFESTOQUELOTE_CDLOCALESTOQ,
                                                 @C_VERIFESTOQUELOTE_CDPRODUTO,
                                                 @C_VERIFESTOQUELOTE_NRLOTEESTQ,
                                                 @C_VERIFESTOQUELOTE_NRSUBLOTE,
                                                 @C_VERIFESTOQUELOTE_QTINVELOTE,
                                                 @C_VERIFESTOQUELOTE_QTESTOLOTE,
                                                 @C_VERIFESTOQUELOTE_NMPRODUTO,
                                                 @C_VERIFESTOQUELOTE_CDARVPROD;
         WHILE @@FETCH_STATUS = 0 BEGIN
            SELECT @V_QTLANCSAID = ISNULL(SUM(A.QTLANCTOEST), 0)
              FROM ITLANCTOEST A, PRODUTO B
             WHERE (A.CDFILIMOVI = @P_CDFILIMOVI)
               AND (A.CDPRODUTO = @C_VERIFESTOQUELOTE_CDPRODUTO)
               AND (B.CDPRODUTO = A.CDPRODUTO)
               AND (A.CDALMOXARIFE = @C_VERIFESTOQUELOTE_CDALMOXARIFE)
               AND (A.CDLOCALESTOQ = @C_VERIFESTOQUELOTE_CDLOCALESTOQ)
               AND (A.IDTIPOMOVI IN ('3','4'))
               AND (A.DTLANCMOVI BETWEEN @P_DATAPROC AND GETDATE() + (SELECT CASE ISNULL(NRDIASSAIDPDFIL, '') WHEN ''
                                                                                THEN
                                                                                   (SELECT NRDIASSAIDPD FROM PARAMESTOQUE)
                                                                                ELSE
                                                                                   NRDIASSAIDPDFIL
                                                                                END NRDIASSAIDA
                                                                     FROM PARAMFILIAL
                                                                    WHERE CDFILIAL = @P_CDFILIMOVI))
            GROUP BY A.CDFILIAL,A.CDPRODUTO, A.DTLANCMOVI,B.NMPRODUTO;

            IF (@V_QTLANCSAID  > @C_VERIFESTOQUELOTE_QTINVELOTE) BEGIN
              SET @V_NRITEMIRREG = @V_NRITEMIRREG +1;
              INSERT INTO TRAB_IRREG_EST (NRLANCIRREST,
                                          NRITEMIRREG,
                                          CDFILIAL,
                                          CDPRODUTO,
                                          NMPRODUTO,
                                          CDALMOXARIFE,
                                          CDLOCALESTOQ,
                                          NRLOTEESTQ,
                                          NRSUBLOTE,
                                          QTINVEROTA,
                                          QTLANCSAID)
              VALUES (@V_NRLANCIRREST,
                      @V_NRITEMIRREG,
                      @C_VERIFESTOQUELOTE_CDFILIAL,
                      @C_VERIFESTOQUELOTE_CDPRODUTO,
                      @C_VERIFESTOQUELOTE_NMPRODUTO,
                      @C_VERIFESTOQUELOTE_CDALMOXARIFE,
                      @C_VERIFESTOQUELOTE_CDLOCALESTOQ,
                      @C_VERIFESTOQUELOTE_NRLOTEESTQ,
                      @C_VERIFESTOQUELOTE_NRSUBLOTE,
                      @C_VERIFESTOQUELOTE_QTINVELOTE,
                      @V_QTLANCSAID);
              SET @V_COUNTIRREG = @V_COUNTIRREG + 1;
              COMMIT;
            END;
            FETCH NEXT FROM C_VERIFESTOQUELOTE INTO @C_VERIFESTOQUELOTE_CDFILIAL,
                                                 @C_VERIFESTOQUELOTE_DTINVELOTE,
                                                 @C_VERIFESTOQUELOTE_CDALMOXARIFE,
                                                 @C_VERIFESTOQUELOTE_CDLOCALESTOQ,
                                                 @C_VERIFESTOQUELOTE_CDPRODUTO,
                                                 @C_VERIFESTOQUELOTE_NRLOTEESTQ,
                                                 @C_VERIFESTOQUELOTE_NRSUBLOTE,
                                                 @C_VERIFESTOQUELOTE_QTINVELOTE,
                                                 @C_VERIFESTOQUELOTE_QTESTOLOTE,
                                                 @C_VERIFESTOQUELOTE_NMPRODUTO,
                                                 @C_VERIFESTOQUELOTE_CDARVPROD;
         END;

         IF (@V_COUNTIRREG  > 0) BEGIN
            RAISERROR(@V_NRLANCIRREST, 16, 1);
         END;
      END;

      /* INVENTRIO ROTATIVO POR LOTE */
      /* INICIO */
      DECLARE C_ATUAINVLOTEOK CURSOR FOR
      SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE, I.QTINVELOTE, I.QTESTOLOTE
           FROM INVEROTALOTE I, PRODUTO P,
                (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                   FROM INVEROTALOTE
                  WHERE CDFILIAL = @P_CDFILIAL
                    AND ((CHARINDEX('_' + CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
                    AND ((CHARINDEX('_' + CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
                    AND DTINVELOTE < @P_DATAPROC
                  GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
          WHERE I.CDFILIAL = @P_CDFILIAL
            AND ((CHARINDEX('_' + I.CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
            AND ((CHARINDEX('_' + I.CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
            AND I.IDINVLOTEOK = 'N'
            AND I.CDFILIAL = X.CDFILIAL
            AND I.CDPRODUTO = X.CDPRODUTO
            AND I.CDALMOXARIFE = X.CDALMOXARIFE
            AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
            AND I.NRLOTEESTQ = X.NRLOTEESTQ
            AND I.NRSUBLOTE = X.NRSUBLOTE
            AND I.DTINVELOTE = X.DTINVELOTE
            AND I.CDPRODUTO  = P.CDPRODUTO
          ORDER BY I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ;

       OPEN C_ATUAINVLOTEOK;
       FETCH NEXT FROM C_ATUAINVLOTEOK INTO @V_INVLTCDFILIAL, @V_INVLTDTINVELOTE, @V_INVLTCDALMOXARIFE, @V_INVLTCDLOCALESTOQ, @V_INVLTCDPRODUTO,
                                            @V_INVLTNRLOTEESTQ, @V_INVLTNRSUBLOTE, @V_INVLTQTINVELOTE, @V_INVLTQTESTOLOTE;

       WHILE (@@FETCH_STATUS = 0) BEGIN
          SELECT @V_CDPRODESTO = CDPRODESTO, @V_VRFATOCONV = VRFATOCONV
            FROM PRODUTO
           WHERE CDPRODUTO = @V_INVLTCDPRODUTO;

          SET @V_CUSTOPROD = TEKNISA.CUSTO_PRODUTO_LCEST(@V_INVLTCDFILIAL, @V_CDPRODESTO, 3, @P_DATAPROC, GETDATE(), @V_INVLTCDALMOXARIFE,
                                                         @V_INVLTCDLOCALESTOQ, @V_INVLTNRLOTEESTQ, @V_INVLTNRSUBLOTE) * @V_VRFATOCONV;


          IF @V_CUSTOPROD IS NULL BEGIN
             SET @V_CUSTOPROD = 0;
          END
          ELSE BEGIN
             SET @V_CUSTOPROD = @V_CUSTOPROD * @V_VRFATOCONV
          END;

          IF (@V_INVLTQTESTOLOTE = 0) BEGIN
             SET @V_QTESTOQDIA = @V_INVLTQTESTOLOTE;
          END
          ELSE BEGIN
             SET @V_QTESTOQDIA = @V_INVLTQTESTOLOTE / @V_VRFATOCONV;
          END;

          IF (@V_VRFATOCONV = 1) BEGIN
             SET @V_QTINVROTA = @V_INVLTQTINVELOTE;
          END
          ELSE BEGIN
             SET @V_QTINVROTA = @V_INVLTQTINVELOTE * @V_VRFATOCONV;
          END;

          IF (@V_IDORDAJUINVE = 'U') BEGIN
             SET @V_DTPOSESTDIA = @V_INVDTINVEROTA;
          END
          ELSE BEGIN
             SET @V_DTPOSESTDIA = @V_INVDTINVEROTA - 1;
          END;

          IF (@V_CUSTOPROD > 0) BEGIN
             SET @V_TIPOMOV = '1';
             /* CASO HAJA UMA MUDANA DE ALMOXARIFADO OU LOCALIZAO, OU O NMERO DE ITENS DE LANAMENTOS ATINGIR SEU VALOR MXIMO,
                SER INCLUDO UM NOVO AJUSTE */
             IF ((@V_ALMOXARIF <> @V_INVLTCDALMOXARIFE) OR (@V_LOCALEST <> @V_INVLTCDLOCALESTOQ) OR (@V_NRSEQAJU = 9999)) BEGIN
                IF (@V_NRAJUSTE IS NOT NULL) BEGIN
                   IF ((@P_INOPCAO = 3) AND ((@V_ALMOXARIF <> @V_INVLTCDALMOXARIFE) OR (@V_LOCALEST <> @V_INVLTCDLOCALESTOQ))) BEGIN
                     /* SE A OPO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
                        E QUE NO ESTO CADASTRADOS NO INVENTRIO, SERO ZERADOS */
                      DECLARE C_ZERAEST CURSOR FOR
                      SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
                        FROM POSESTDIA A,
                             (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                                FROM POSESTDIA
                               WHERE CDFILIAL = @P_CDFILIAL
                                 AND CDALMOXARIFE = @V_ALMOXARIF
                                 AND CDLOCALESTOQ = @V_LOCALEST
                                 AND DTPOSIESTQ < @V_DTMOVI
                               GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
                       WHERE A.CDFILIAL = @P_CDFILIAL
                         AND A.CDALMOXARIFE = @V_ALMOXARIF
                         AND A.CDLOCALESTOQ = @V_LOCALEST
                         AND A.CDFILIAL = X.CDFILIAL
                         AND A.CDPRODUTO = X.CDPRODUTO
                         AND A.CDALMOXARIFE = X.CDALMOXARIFE
                         AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                         AND A.NRLOTEESTQ = X.NRLOTEESTQ
                         AND A.NRSUBLOTE = X.NRSUBLOTE
                         AND A.DTPOSIESTQ = X.DTPOSIESTQ
                         AND A.QTESTOQDIA <> 0
                         AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE
                                           FROM INVEROTALOTE I,
                                                (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                                                   FROM INVEROTALOTE
                                                  WHERE CDFILIAL = @P_CDFILIAL
                                                    AND CDALMOXARIFE = @V_ALMOXARIF
                                                    AND CDLOCALESTOQ = @V_LOCALEST
                                                    AND DTINVELOTE < @V_DTMOVI
                                                  GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) B
                                          WHERE I.CDFILIAL = @P_CDFILIAL
                                            AND I.CDALMOXARIFE = @V_ALMOXARIF
                                            AND I.CDLOCALESTOQ = @V_LOCALEST
                                            AND I.CDFILIAL = B.CDFILIAL
                                            AND I.CDPRODUTO = B.CDPRODUTO
                                            AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                            AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                            AND I.NRLOTEESTQ = B.NRLOTEESTQ
                                            AND I.NRSUBLOTE = B.NRSUBLOTE
                                            AND I.DTINVELOTE = B.DTINVELOTE
                                            AND A.CDFILIAL = I.CDFILIAL
                                            AND A.CDPRODUTO = I.CDPRODUTO
                                            AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                            AND A.CDLOCALESTOQ = I.CDLOCALESTOQ
                                            AND A.NRLOTEESTQ = I.NRLOTEESTQ
                                            AND A.NRSUBLOTE = I.NRSUBLOTE);

                      OPEN C_ZERAEST;
                      FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;

                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         IF (@V_NRSEQAJU = 9999) BEGIN
                            /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZAO ANTERIOR */
                            IF (@P_EVOLEST = 'S') BEGIN
                               DECLARE C_MOVILOTE CURSOR FOR
                               SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                 FROM MOVILOTE
                                WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;

                               OPEN C_MOVILOTE;
                               FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                             @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;

                               WHILE (@@FETCH_STATUS = 0) BEGIN
                                  UPDATE ITLANCTOEST
                                     SET IDEVOLESTOQ = 'S'
                                   WHERE CDFILIAL = @P_CDFILIAL
                                     AND NRLANCESTQ = @V_NRAJUSTE
                                     AND CDPRODUTO = @V_MCDPRODUTO
                                     AND CDALMOXARIFE = @V_MCDALMOXARIFE
                                     AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                                     AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                                     AND NRSUBLOTE = @V_MNRSUBLOTE;

                                  FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                                  @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               END;
                               CLOSE C_MOVILOTE;
                               DEALLOCATE C_MOVILOTE;

                               EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
                            END
                            ELSE BEGIN
                               UPDATE ITLANCTOEST
                                  SET IDEVOLESTOQ = 'N'
                                WHERE CDFILIAL = @P_CDFILIAL
                                  AND NRLANCESTQ = @V_NRAJUSTE;
                            END;
                            SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                            SET @V_NRAJUSTE = SUBSTRING(@V_SEQUENCIAL, 11, 20);

                            INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                            VALUES (@P_CDFILIAL, @V_NRAJUSTE, @V_TIPOMOV, @V_DTMOVI, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);

                            SET @V_NRSEQAJU = 0;
                         END;

                         SET @V_NRSEQAJU = @V_NRSEQAJU + 1;

                         INSERT INTO ITLANCTOEST
                         (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE,
                         CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                         VALUES
                         (@P_CDFILIAL, @V_NRAJUSTE, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_ZCDPRODUTO, 0, 0, @V_ZCDPRODUTO, 'N', @P_CDFILIMOVI, @V_ZCDALMOXARIFE,
                         @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE, '1', 0, 0, @V_DTMOVI, 0, 0, @V_IDORDEMCLC);

                         UPDATE ETIQUETAPRODOL
                            SET IDSTATUSETIQ = 'I',
                                DSNOTAFISORIGET = 'INV '+CONVERT(VARCHAR, GETDATE(), 103)
                           FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                         AND E.NRLANCTONF  = I.NRLANCTONF
                                                                         AND E.NRSEQITPROD = I.NRSEQITPROD
                          WHERE I.CDFILIMOVI   = @P_CDFILIMOVI
                            AND I.CDPRODUTO    = @V_ZCDPRODUTO
                            AND I.CDALMOXARIFE = @V_ZCDALMOXARIFE
                            AND I.NRLOTEESTQ   = @V_ZNRLOTEESTQ
                            AND I.CDLOCALESTOQ = @V_ZCDLOCALESTOQ
                            AND I.NRSUBLOTE    = @V_ZNRSUBLOTE
                            AND E.IDSTATUSETIQ <> 'I';

                         FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;
                      END;
                      CLOSE C_ZERAEST;
                      DEALLOCATE C_ZERAEST;
                   END;
                   /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZAO ANTERIOR */
                   IF (@P_EVOLEST = 'S') BEGIN
                      DECLARE C_MOVILOTE CURSOR FOR
                      SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                        FROM MOVILOTE
                       WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;

                      OPEN C_MOVILOTE;
                      FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                      @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;

                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         UPDATE ITLANCTOEST
                            SET IDEVOLESTOQ = 'S'
                          WHERE CDFILIAL = @P_CDFILIAL
                            AND NRLANCESTQ = @V_NRAJUSTE
                            AND CDPRODUTO = @V_MCDPRODUTO
                            AND CDALMOXARIFE = @V_MCDALMOXARIFE
                            AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                            AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                            AND NRSUBLOTE = @V_MNRSUBLOTE;

                         FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                         @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                      END;
                      CLOSE C_MOVILOTE;
                      DEALLOCATE C_MOVILOTE;

                      EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
                   END
                   ELSE BEGIN
                      UPDATE ITLANCTOEST
                         SET IDEVOLESTOQ = 'N'
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCESTQ = @V_NRAJUSTE;
                   END;
                END;
                SET @V_ALMOXARIF = @V_INVLTCDALMOXARIFE;
                SET @V_LOCALEST = @V_INVLTCDLOCALESTOQ;
                SET @V_DTMOVI   = @V_INVLTDTINVELOTE;

                SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                SET @V_NRAJUSTE = SUBSTRING(@V_SEQUENCIAL, 11, 20);

                SET @V_DESCALMOX = 'Ajuste para Inventrio Rotativo';
                IF (@V_IDUTILALMOX = 'S') BEGIN
                   SET @V_DESCALMOX = @V_DESCALMOX + ' - Almox. ' + @V_INVLTCDALMOXARIFE;
                   IF (@V_IDUTILLCESTQ = 'S') BEGIN
                      SET @V_DESCALMOX = @V_DESCALMOX + ' Local. ' + @V_INVLTCDLOCALESTOQ;
                   END;
                END;

                /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - AJUSTE */
                INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                VALUES (@V_INVLTCDFILIAL, @V_NRAJUSTE, @V_TIPOMOV, @V_INVLTDTINVELOTE, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);

                SET @V_NRSEQAJU = 0;
             END;
             SET @V_NRSEQAJU = @V_NRSEQAJU + 1;

             IF (@V_IDGERARETAJU = 'S') BEGIN
                /* SE EST PARAMETRIZADO PARA REALIZAR RETIRADA AO REALIZAR AJUSTE NO ESTOQUE */
                IF (@P_RETIESTQ <> 'S') BEGIN
                   /* SE A RETIRADA  POR SERVIO */
                   IF ((@P_CDSERVFILI IS NOT NULL) AND (@V_INVLTQTINVELOTE < @V_QTESTOQDIA)) BEGIN
                      /* SE O SERVIO FOI INFORMADO E SE A QUANTIDADE DO INVENTARIO  MENOR QUE A QUANTIDADE EM ESTOQUE */
                      IF ((@V_NRLANCVER IS NULL) OR (@V_NRLANCVER <> @V_NRAJUSTE)) BEGIN
                         /* VERIFICA SE HOUVE MUDANA DE LANAMENTO DE AJUSTE */
                         IF (@V_NRLANCVER IS NOT NULL) BEGIN
                            /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTAO ANTERIOR */
                            IF (@P_EVOLEST = 'S') BEGIN
                               DECLARE C_MOVILOTE CURSOR FOR
                               SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                 FROM MOVILOTE
                                WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRLANCESTRET;

                               OPEN C_MOVILOTE;
                               FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                               @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;

                               WHILE (@@FETCH_STATUS = 0) BEGIN
                                  UPDATE ITLANCTOEST
                                     SET IDEVOLESTOQ = 'S'
                                   WHERE CDFILIAL = @P_CDFILIAL
                                     AND NRLANCESTQ = @V_NRLANCESTRET
                                     AND CDPRODUTO = @V_MCDPRODUTO
                                     AND CDALMOXARIFE = @V_MCDALMOXARIFE
                                     AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                                     AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                                     AND NRSUBLOTE = @V_MNRSUBLOTE;

                                  FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                                  @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               END;
                               CLOSE C_MOVILOTE;
                               DEALLOCATE C_MOVILOTE;

                               EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRLANCESTRET;
                            END
                            ELSE BEGIN
                               UPDATE ITLANCTOEST
                                  SET IDEVOLESTOQ = 'N'
                                WHERE CDFILIAL = @P_CDFILIAL
                                  AND NRLANCESTQ = @V_NRLANCESTRET;
                            END;
                         END;
                         /* CARREGA AS INFORMAES DA RETIRADA, DO CARDAPIO E DA RETIRADA DE ESTOQUE REFERENTES AO AJUSTE INFORMADO */
                         SELECT @V_NRLANCESTRET = AR.NRLANCESTRET, @V_NRRETIRADA = RE.NRRETIRADA, @V_NRCARDAPIO = CD.NRCARDAPIO
                           FROM CARDADIA CD, RETIRADA RE, AJURELACRET AR
                          WHERE CD.NRCARDAPIO = RE.NRCARDAPIO
                            AND CD.CDFILIAL = RE.CDFILIAL
                            AND RE.NRLANCESTQ = AR.NRLANCESTRET
                            AND RE.CDFILANCESTQ = AR.CDFILIAL
                            AND AR.CDFILIALRET = @V_INVLTCDFILIAL
                            AND AR.NRLANCESTQ = @V_NRAJUSTE
                            AND AR.CDFILIAL = @V_INVLTCDFILIAL;

                         IF ((@V_NRLANCESTRET IS NULL) AND (@V_NRRETIRADA IS NULL) AND (@V_NRCARDAPIO IS NULL)) BEGIN
                            /* CASO NO TENHA INFORMAES DE RETIRADA CADASTRADAS */

                            /* LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                            SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                            SET @V_NRLANCESTRET = SUBSTRING(@V_SEQUENCIAL, 11, 20);

                            INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                            VALUES (@P_CDFILIAL, @V_NRLANCESTRET, '3', @V_DTPOSESTDIA, @P_CDFILIMOVI, @P_CDOPERADOR, 'Retirada para Ajuste : '+ @V_NRAJUSTE);

                            /* CARDPIO */
                            /* VERIFICA A EXISTNCIA DE CARDAPIO */
                            SELECT @V_NRCARDAPIO = NRCARDAPIO
                              FROM CARDADIA
                             WHERE CDFILIAL = @V_INVLTCDFILIAL
                               AND CDSERVFILI = @P_CDSERVFILI
                               AND DTCARDAPIO = @V_DTPOSESTDIA;

                            IF (@V_NRCARDAPIO IS NULL) BEGIN
                               /* SE NO EXISTIR CARDAPIO, SER INCLUIDO UM NOVO */
                               SET @V_NOVOCODIGO = 'CARDAPIO' + @P_CDFILIAL;
                               EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                               SET @V_NRCARDAPIO = SUBSTRING(@V_SEQUENCIAL, 11, 20);

                               INSERT INTO CARDADIA
                               (CDFILIAL, NRCARDAPIO, CDSERVFILI, CDOPERADOR, DTCARDAPIO, DTMESCARD)
                               VALUES
                               (@P_CDFILIAL, @V_NRCARDAPIO, @P_CDSERVFILI, @P_CDOPERADOR, @V_DTPOSESTDIA, CONVERT(DATETIME, '01/' + SUBSTRING(CONVERT(VARCHAR, @V_DTPOSESTDIA, 103), 4, 7), 103));
                            END;
                            /* RETIRADA */
                            SET @V_NOVOCODIGO = 'RETIRADA' + @V_INVLTCDFILIAL;
                            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                            SET @V_NRRETIRADA = SUBSTRING(@V_SEQUENCIAL, 11, 20);

                            INSERT INTO RETIRADA
                            (CDFILIAL, NRRETIRADA, NRCARDAPIO, DTRETIRADA, CDFILANCESTQ, NRLANCESTQ)
                            VALUES
                            (@P_CDFILIMOVI, @V_NRRETIRADA, @V_NRCARDAPIO, @V_DTPOSESTDIA, @P_CDFILIAL, @V_NRLANCESTRET);

                            /* RELACIONAMENTO AJUSTE/RETIRADA */
                            INSERT INTO AJURELACRET
                            (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                            VALUES
                            (@V_INVLTCDFILIAL, @V_NRAJUSTE, @P_CDFILIAL, @V_NRLANCESTRET);
                         END;

                         /* VERIFICA SE O LANAMENTO DE RETIRADA DE ESTOQUE POSSUI REGISTRO (A AVALIAR)*/
                         SELECT @V_CONTADOR = COUNT(*)
                           FROM ITLANCTOEST
                          WHERE CDFILIAL = @V_INVLTCDFILIAL
                            AND NRLANCESTQ = @V_NRLANCESTRET;

                         IF @V_CONTADOR > 0 BEGIN
                            /* CASO EXISTA REGISTROS, ESSES REGISTROS SERO DELETADOS (A AVALIAR) */
                            DELETE FROM ITEMRETI
                             WHERE CDFILIAL = @V_INVLTCDFILIAL
                               AND NRRETIRADA = @V_NRRETIRADA
                               AND NRCARDAPIO = @V_NRCARDAPIO;

                            DELETE FROM ITLANCTOEST
                             WHERE CDFILIAL = @V_INVLTCDFILIAL
                               AND NRLANCESTQ = @V_NRLANCESTRET;
                         END;

                         SET @V_NRLANCVER = @V_NRAJUSTE;
                      END;
                      /* NESTE LOCAL DA TELA TEM UMA VERIFICAO NA TELA DE INVENTRIO QUE, CASO O LANAMENTO DE ESTOQUE - RETIRADA TENHA
                         ALGUM ITEM CADASTRADO NAQUELA POSIO DE ITEM, SER DELETADO PARA INSERIR UM NOVO REGISTRO NESTA POSIO (A VERIFICAR) */

                      /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                      INSERT INTO ITLANCTOEST
                      (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST,
                      QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI,
                      IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO)
                      VALUES
                      (@V_INVLTCDFILIAL, @V_NRLANCESTRET, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVLTCDPRODUTO, (@V_QTESTOQDIA - @V_INVLTQTINVELOTE),
                      (@V_QTESTOQDIA - @V_INVLTQTINVELOTE), @V_CDPRODESTO, @P_CDFILIMOVI, @V_INVLTCDALMOXARIFE, @V_INVLTCDLOCALESTOQ, @V_INVLTNRLOTEESTQ, @V_INVLTNRSUBLOTE,
                      '3', 'N', '9', @P_CDTIPORETI, @V_CUSTOPROD, ((@V_QTESTOQDIA - @V_INVLTQTINVELOTE) * @V_CUSTOPROD));

                      /* INSERE O ITEM DE RETIRADA */
                      INSERT INTO ITEMRETI
                      (CDFILIAL, NRRETIRADA, NRCARDAPIO, NRSEQUITRETI, CDPRODUTO,
                      QTRETIRADA, CDFIITLANEST, NRLANCESTQ, NRSEQUITEM, CDTIPORETI)
                      VALUES
                      (@P_CDFILIMOVI, @V_NRRETIRADA, @V_NRCARDAPIO, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVLTCDPRODUTO,
                      (@V_QTESTOQDIA - @V_INVLTQTINVELOTE), @V_INVLTCDFILIAL, @V_NRLANCESTRET, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @P_CDTIPORETI);
                   END;
                END
                ELSE BEGIN
                   IF (@V_INVLTQTINVELOTE < @V_QTESTOQDIA) BEGIN
                      IF ((@V_NRLANCVER IS NULL) OR (@V_NRLANCVER <> @V_NRAJUSTE)) BEGIN
                         /* SE HOUVE MUDANA DO AJUSTE */
                         IF (@V_NRLANCVER IS NOT NULL) BEGIN
                            /* ATUALIZA O ESTOQUE REFERENTE A MOVIMENTAO ANTERIOR */
                            IF (@P_EVOLEST = 'S') BEGIN
                               DECLARE C_MOVILOTE CURSOR FOR
                               SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                                 FROM MOVILOTE
                                WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRLANCESTRET;

                               OPEN C_MOVILOTE;
                               FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                               @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               
                               WHILE (@@FETCH_STATUS = 0) BEGIN
                                  UPDATE ITLANCTOEST
                                     SET IDEVOLESTOQ = 'S'
                                   WHERE CDFILIAL = @P_CDFILIAL
                                     AND NRLANCESTQ = @V_NRLANCESTRET
                                     AND CDPRODUTO = @V_MCDPRODUTO
                                     AND CDALMOXARIFE = @V_MCDALMOXARIFE
                                     AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                                     AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                                     AND NRSUBLOTE = @V_MNRSUBLOTE;
                                
                                  FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                                  @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                               END;
                               CLOSE C_MOVILOTE;
                               DEALLOCATE C_MOVILOTE;
                             
                               EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRLANCESTRET;
                            END
                            ELSE BEGIN
                               UPDATE ITLANCTOEST
                                  SET IDEVOLESTOQ = 'N'
                                WHERE CDFILIAL = @P_CDFILIAL
                                  AND NRLANCESTQ = @V_NRLANCESTRET;
                            END;
                         END;
                           
                         /* LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                         SET @V_NOVOCODIGO = 'LANCTOEST' + @V_INVLTCDFILIAL;
                         EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                         SET @V_NRLANCESTRET = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                           
                         INSERT INTO LANCTOESTOQ
                         (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, CDOPERADOR, CDFILIMOVI)
                         VALUES
                         (@V_INVLTCDFILIAL, @V_NRLANCESTRET, '3', @V_DTPOSESTDIA, 'Retirada para Ajuste', @P_CDOPERADOR, @P_CDFILIMOVI);
                           
                         /* RETIRADA DE ESTOQUE */
                         SET @V_NOVOCODIGO = 'RETIESTO' + @V_INVLTCDFILIAL;
                         EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                         SET @V_NRRETIRADA = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                           
                         INSERT INTO RETIRADAESTO
                         (CDFILIAL, NRRETEST, DTRETEST, DSRETEST, CDFILIALLAN, NRLANCESTQ, CDSETOR, CDCENTCUST, NRORDPROD, NRREQUESTO)
                         VALUES
                         (@P_CDFILIMOVI, @V_NRRETIRADA, @V_DTPOSESTDIA, 'Retirada para Ajuste', @V_INVLTCDFILIAL, @V_NRLANCESTRET, @P_CDSETOR, @P_CDCENTCUST, NULL, NULL);
                           
                         /* RELACIONAMENTO AJUSTE/RETIRADA */
                         INSERT INTO AJURELACRET
                         (CDFILIAL, NRLANCESTQ, CDFILIALRET, NRLANCESTRET)
                         VALUES
                         (@V_INVLTCDFILIAL, @V_NRAJUSTE, @V_INVLTCDFILIAL, @V_NRLANCESTRET);
                           
                         SET @V_NRLANCVER = @V_NRAJUSTE;
                      END;
                      
                      /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - RETIRADA */
                      INSERT INTO ITLANCTOEST
                      (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, 
                      QTTOTLANCTO, CDPRODMOVI, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, 
                      IDEVOLESTOQ, IDORDEMCLC, CDTIPORETI, VRUNILANCTO, VRTOTLANCTO, CDCENTCUST)
                      VALUES
                      (@V_INVLTCDFILIAL, @V_NRLANCESTRET, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVLTCDPRODUTO, (@V_QTESTOQDIA - @V_INVLTQTINVELOTE),
                      (@V_QTESTOQDIA - @V_INVLTQTINVELOTE), @V_CDPRODESTO, @P_CDFILIMOVI, @V_INVLTCDALMOXARIFE, @V_INVLTCDLOCALESTOQ, @V_INVLTNRLOTEESTQ, @V_INVLTNRSUBLOTE,
                      '3', 'N', '9', @P_CDTIPORETI, @V_CUSTOPROD, ((@V_QTESTOQDIA - @V_INVLTQTINVELOTE) * @V_CUSTOPROD), @P_CDCENTCUST);
                   END;
                END;
             END;
             
             /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - AJUSTE */
             INSERT INTO ITLANCTOEST
             (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
             CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
             NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
             VRTOTLANCTO, IDORDEMCLC)
             VALUES
             (@V_INVLTCDFILIAL, @V_NRAJUSTE, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_INVLTCDPRODUTO, @V_QTINVROTA, @V_INVLTQTINVELOTE,
             @V_CDPRODESTO, 'N', @P_CDFILIMOVI, @V_INVLTCDALMOXARIFE, @V_INVLTCDLOCALESTOQ, @V_INVLTNRLOTEESTQ, @V_INVLTNRSUBLOTE, @V_TIPOMOV, @V_CUSTOPROD,
             @V_CUSTOPROD, @V_INVLTDTINVELOTE, (@V_CUSTOPROD * @V_VRFATOCONV), (@V_CUSTOPROD * @V_INVLTQTINVELOTE), @V_IDORDEMCLC);

             /* ATUALIZA O INVENTRIO DO PRODUTO */
             UPDATE INVEROTALOTE
                SET IDINVLOTEOK = 'S'
              WHERE CDFILIAL = @V_INVLTCDFILIAL
                AND DTINVELOTE = @V_INVLTDTINVELOTE
                AND CDALMOXARIFE = @V_INVLTCDALMOXARIFE
                AND CDLOCALESTOQ = @V_INVLTCDLOCALESTOQ
                AND CDPRODUTO = @V_INVLTCDPRODUTO
                AND NRLOTEESTQ = @V_INVLTNRLOTEESTQ
                AND NRSUBLOTE = @V_INVLTNRSUBLOTE;
          END;
          
          IF (@V_IDCTRLESTQ <> 'N') BEGIN
             /* ATUALIZA REGISTRO DE PRODUTOS POR LOCAL DE ESTOQUE, SE A FILIAL CONTROLA ESTOQUE */
             INSERT INTO PRODLCESTOQ
             (CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO)
             (SELECT @V_INVLTCDFILIAL, @V_INVLTCDALMOXARIFE, @V_INVLTCDLOCALESTOQ, @V_CDPRODESTO
                FROM PRODFILI
               WHERE CDFILIAL = @V_INVLTCDFILIAL
                 AND CDPRODUTO = @V_CDPRODESTO
                 AND ISNULL(IDCNTRESTOQ, 'S') <> 'N'
                 AND NOT EXISTS(SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, CDPRODUTO
                                  FROM PRODLCESTOQ
                                 WHERE CDFILIAL = @V_INVLTCDFILIAL
                                   AND CDALMOXARIFE = @V_INVLTCDALMOXARIFE
                                   AND CDLOCALESTOQ = @V_INVLTCDLOCALESTOQ
                                   AND CDPRODUTO = @V_CDPRODESTO));
          END;

          FETCH NEXT FROM C_ATUAINVLOTEOK INTO @V_INVLTCDFILIAL, @V_INVLTDTINVELOTE, @V_INVLTCDALMOXARIFE, @V_INVLTCDLOCALESTOQ, @V_INVLTCDPRODUTO, 
                                               @V_INVLTNRLOTEESTQ, @V_INVLTNRSUBLOTE, @V_INVLTQTINVELOTE, @V_INVLTQTESTOLOTE;
       END;
       CLOSE C_ATUAINVLOTEOK;
       DEALLOCATE C_ATUAINVLOTEOK;
       
       IF (@V_NRAJUSTE IS NOT NULL) BEGIN
          IF (@P_INOPCAO = 3) BEGIN
             /* SE A OPO DE ZERAR O ESTOQUE FOI SELECIONADA, TODOS OS PRODUTOS QUE POSSUEM QUANTIDADE NO ESTOQUE
                E QUE NO ESTO CADASTRADOS NO INVENTRIO, SERO ZERADOS */
             DECLARE C_ZERAEST CURSOR FOR
             SELECT A.CDPRODUTO, A.CDALMOXARIFE, A.CDLOCALESTOQ, A.NRLOTEESTQ, A.NRSUBLOTE
               FROM POSESTDIA A,
                    (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTPOSIESTQ) AS DTPOSIESTQ
                       FROM POSESTDIA
                      WHERE CDFILIAL = @P_CDFILIAL
                        AND CDALMOXARIFE = @V_ALMOXARIF
                        AND CDLOCALESTOQ = @V_LOCALEST
                        AND DTPOSIESTQ < @V_DTMOVI
                      GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
              WHERE A.CDFILIAL = @P_CDFILIAL
                AND A.CDALMOXARIFE = @V_ALMOXARIF
                AND A.CDLOCALESTOQ = @V_LOCALEST
                AND A.CDFILIAL = X.CDFILIAL
                AND A.CDPRODUTO = X.CDPRODUTO
                AND A.CDALMOXARIFE = X.CDALMOXARIFE
                AND A.CDLOCALESTOQ = X.CDLOCALESTOQ
                AND A.NRLOTEESTQ = X.NRLOTEESTQ
                AND A.NRSUBLOTE = X.NRSUBLOTE
                AND A.DTPOSIESTQ = X.DTPOSIESTQ
                AND A.QTESTOQDIA <> 0
                AND NOT EXISTS (SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE
                                  FROM INVEROTALOTE I,
                                       (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                                          FROM INVEROTALOTE
                                         WHERE CDFILIAL = @P_CDFILIAL
                                           AND CDALMOXARIFE = @V_ALMOXARIF
                                           AND CDLOCALESTOQ = @V_LOCALEST
                                           AND DTINVELOTE < @V_DTMOVI
                                         GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) B
                                 WHERE I.CDFILIAL = @P_CDFILIAL
                                   AND I.CDALMOXARIFE = @V_ALMOXARIF
                                   AND I.CDLOCALESTOQ = @V_LOCALEST
                                   AND I.CDFILIAL = B.CDFILIAL
                                   AND I.CDPRODUTO = B.CDPRODUTO
                                   AND I.CDALMOXARIFE = B.CDALMOXARIFE
                                   AND I.CDLOCALESTOQ = B.CDLOCALESTOQ
                                   AND I.NRLOTEESTQ = B.NRLOTEESTQ
                                   AND I.NRSUBLOTE = B.NRSUBLOTE
                                   AND I.DTINVELOTE = B.DTINVELOTE
                                   AND A.CDFILIAL = I.CDFILIAL
                                   AND A.CDPRODUTO = I.CDPRODUTO
                                   AND A.CDALMOXARIFE = I.CDALMOXARIFE
                                   AND A.CDLOCALESTOQ = I.CDLOCALESTOQ
                                   AND A.NRLOTEESTQ = I.NRLOTEESTQ
                                   AND A.NRSUBLOTE = I.NRSUBLOTE);
                   
             OPEN C_ZERAEST;
             FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;
                   
             WHILE (@@FETCH_STATUS = 0) BEGIN
                IF (@V_NRSEQAJU = 9999) BEGIN
                   /* ATUALIZA O ESTOQUE REFERENTE A ATUALIZAO ANTERIOR */
                   IF (@P_EVOLEST = 'S') BEGIN
                      DECLARE C_MOVILOTE CURSOR FOR
                      SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                        FROM MOVILOTE 
                       WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;
                      
                      OPEN C_MOVILOTE;
                      FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                      @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                             
                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         UPDATE ITLANCTOEST
                            SET IDEVOLESTOQ = 'S'
                          WHERE CDFILIAL = @P_CDFILIAL
                            AND NRLANCESTQ = @V_NRAJUSTE
                            AND CDPRODUTO = @V_MCDPRODUTO
                            AND CDALMOXARIFE = @V_MCDALMOXARIFE
                            AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                            AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                            AND NRSUBLOTE = @V_MNRSUBLOTE;
                         
                         FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                         @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                      END;
                      CLOSE C_MOVILOTE;
                      DEALLOCATE C_MOVILOTE;
                      
                      EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
                   END
                   ELSE BEGIN
                      UPDATE ITLANCTOEST
                         SET IDEVOLESTOQ = 'N'
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCESTQ = @V_NRAJUSTE;
                   END;
                   SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
                   EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
                   SET @V_NRAJUSTE = SUBSTRING(@V_SEQUENCIAL, 11, 20);
                   
                   INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
                   VALUES (@P_CDFILIAL, @V_NRAJUSTE, @V_TIPOMOV, @V_DTMOVI, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);
                   
                   SET @V_NRSEQAJU = 0;
                END;
                
                SET @V_NRSEQAJU = @V_NRSEQAJU + 1;
                
                INSERT INTO ITLANCTOEST
                (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO, CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, 
                CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO, VRTOTLANCTO, IDORDEMCLC)
                VALUES
                (@P_CDFILIAL, @V_NRAJUSTE, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQAJU),4), @V_ZCDPRODUTO, 0, 0, @V_ZCDPRODUTO, 'N', @P_CDFILIMOVI, @V_ZCDALMOXARIFE, 
                @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE, '1', 0, 0, @V_DTMOVI, 0, 0, @V_IDORDEMCLC);

                UPDATE ETIQUETAPRODOL
                   SET IDSTATUSETIQ = 'I',
                       DSNOTAFISORIGET = 'INV '+CONVERT(VARCHAR, GETDATE(), 103)
                  FROM ETIQUETAPRODOL E INNER JOIN ITEMPRODUTO I ON E.CDFILIAL    = I.CDFILIAL
                                                                AND E.NRLANCTONF  = I.NRLANCTONF
                                                                AND E.NRSEQITPROD = I.NRSEQITPROD
                 WHERE I.CDFILIMOVI   = @P_CDFILIMOVI
                   AND I.CDPRODUTO    = @V_ZCDPRODUTO
                   AND I.CDALMOXARIFE = @V_ZCDALMOXARIFE
                   AND I.NRLOTEESTQ   = @V_ZNRLOTEESTQ
                   AND I.CDLOCALESTOQ = @V_ZCDLOCALESTOQ
                   AND I.NRSUBLOTE    = @V_ZNRSUBLOTE
                   AND E.IDSTATUSETIQ <> 'I';
                
                FETCH NEXT FROM C_ZERAEST INTO @V_ZCDPRODUTO, @V_ZCDALMOXARIFE, @V_ZCDLOCALESTOQ, @V_ZNRLOTEESTQ, @V_ZNRSUBLOTE;
             END;
             CLOSE C_ZERAEST;
             DEALLOCATE C_ZERAEST;
          END;
          /* ATUALIZA A ULTIMA MOVIMENTAO DE AJUSTE E MOVIMENTAO DE RETIRADA NO ESTOQUE */
          IF (@P_EVOLEST = 'S') BEGIN
             DECLARE C_MOVILOTE CURSOR FOR
             SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
               FROM MOVILOTE 
              WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRAJUSTE;
             
             OPEN C_MOVILOTE;
             FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                             @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                             
             WHILE (@@FETCH_STATUS = 0) BEGIN
                UPDATE ITLANCTOEST
                   SET IDEVOLESTOQ = 'S'
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCESTQ = @V_NRAJUSTE
                   AND CDPRODUTO = @V_MCDPRODUTO
                   AND CDALMOXARIFE = @V_MCDALMOXARIFE
                   AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                   AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                   AND NRSUBLOTE = @V_MNRSUBLOTE;
                
                FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
             END;
             CLOSE C_MOVILOTE;
             DEALLOCATE C_MOVILOTE;
             
             EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRAJUSTE;
             
             IF (@V_IDGERARETAJU = 'S') BEGIN
                DECLARE C_MOVILOTE CURSOR FOR
                SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                  FROM MOVILOTE 
                 WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRLANCESTRET;
                
                OPEN C_MOVILOTE;
                FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                
                WHILE (@@FETCH_STATUS = 0) BEGIN
                   UPDATE ITLANCTOEST
                      SET IDEVOLESTOQ = 'S'
                    WHERE CDFILIAL = @P_CDFILIAL
                      AND NRLANCESTQ = @V_NRLANCESTRET
                      AND CDPRODUTO = @V_MCDPRODUTO
                      AND CDALMOXARIFE = @V_MCDALMOXARIFE
                      AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                      AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                      AND NRSUBLOTE = @V_MNRSUBLOTE;
                   
                   FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                   @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                END;
                CLOSE C_MOVILOTE;
                DEALLOCATE C_MOVILOTE;
                
                EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRLANCESTRET;
             END;
          END
          ELSE BEGIN
             UPDATE ITLANCTOEST
                SET IDEVOLESTOQ = 'N'
              WHERE CDFILIAL = @P_CDFILIAL
                AND NRLANCESTQ = @V_NRAJUSTE;
             IF (@V_IDGERARETAJU = 'S') BEGIN
                UPDATE ITLANCTOEST
                   SET IDEVOLESTOQ = 'N'
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCESTQ = @V_NRLANCESTRET;
             END;
          END;
       END;
       
       /*    INCLUSO DE IMPLANTAO DE ESTOQUE     */
       SET @V_ALMOXARIF = 'NOVO';
       SET @V_LOCALEST  = 'NOVO';
       
       DECLARE C_VERIFESTOQUELOTE CURSOR FOR
       SELECT I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.CDPRODUTO, I.NRLOTEESTQ, I.NRSUBLOTE, I.QTINVELOTE, I.QTESTOLOTE,P.NMPRODUTO,P.CDARVPROD
         FROM INVEROTALOTE I,PRODUTO P,
              (SELECT CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, MAX(DTINVELOTE) AS DTINVELOTE
                 FROM INVEROTALOTE
                WHERE CDFILIAL = @P_CDFILIAL
                  AND ((CHARINDEX('_' + CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
                  AND ((CHARINDEX('_' + CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
                  AND DTINVELOTE < @P_DATAPROC
                GROUP BY CDFILIAL, CDPRODUTO, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE) X
        WHERE I.CDFILIAL = @P_CDFILIAL
          AND ((CHARINDEX('_' + I.CDALMOXARIFE + '_', @P_CDALMOXARIFE) > 0) OR (@P_CDALMOXARIFE = ' '))
          AND ((CHARINDEX('_' + I.CDLOCALESTOQ + '_', @P_CDLOCALESTOQ) > 0) OR (@P_CDLOCALESTOQ = ' '))
          AND I.IDINVLOTEOK = 'N'
          AND I.CDFILIAL = X.CDFILIAL
          AND I.CDPRODUTO = X.CDPRODUTO
          AND I.CDALMOXARIFE = X.CDALMOXARIFE
          AND I.CDLOCALESTOQ = X.CDLOCALESTOQ
          AND I.NRLOTEESTQ = X.NRLOTEESTQ
          AND I.NRSUBLOTE = X.NRSUBLOTE
          and I.DTINVELOTE = X.DTINVELOTE
          AND I.CDPRODUTO  = P.CDPRODUTO
        ORDER BY I.CDFILIAL, I.DTINVELOTE, I.CDALMOXARIFE, I.CDLOCALESTOQ;
       OPEN C_VERIFESTOQUELOTE;
       FETCH NEXT FROM C_VERIFESTOQUELOTE INTO @C_VERIFESTOQUELOTE_CDFILIAL,
                                               @C_VERIFESTOQUELOTE_DTINVELOTE,
                                               @C_VERIFESTOQUELOTE_CDALMOXARIFE,
                                               @C_VERIFESTOQUELOTE_CDLOCALESTOQ,
                                               @C_VERIFESTOQUELOTE_CDPRODUTO,
                                               @C_VERIFESTOQUELOTE_NRLOTEESTQ,
                                               @C_VERIFESTOQUELOTE_NRSUBLOTE,
                                               @C_VERIFESTOQUELOTE_QTINVELOTE,
                                               @C_VERIFESTOQUELOTE_QTESTOLOTE,
                                               @C_VERIFESTOQUELOTE_NMPRODUTO,
                                               @C_VERIFESTOQUELOTE_CDARVPROD;
       WHILE @@FETCH_STATUS = 0 BEGIN
          SELECT @V_CDPRODESTO = CDPRODESTO, @V_VRFATOCONV = VRFATOCONV
            FROM PRODUTO
           WHERE CDPRODUTO = @C_VERIFESTOQUELOTE_CDPRODUTO;

          SET @V_CUSTOPROD = TEKNISA.CUSTO_PRODUTO_LCEST(@C_VERIFESTOQUELOTE_CDFILIAL, @V_CDPRODESTO, 3, @P_DATAPROC, GETDATE(), @C_VERIFESTOQUELOTE_CDALMOXARIFE,
                                                         @C_VERIFESTOQUELOTE_CDLOCALESTOQ, @C_VERIFESTOQUELOTE_NRLOTEESTQ, @C_VERIFESTOQUELOTE_NRSUBLOTE) * @V_VRFATOCONV;

          IF (@V_INVLTQTESTOLOTE = 0) BEGIN
             SET @V_QTESTOQDIA = @C_VERIFESTOQUELOTE_QTESTOLOTE;
          END
          ELSE BEGIN
             SET @V_QTESTOQDIA = @C_VERIFESTOQUELOTE_QTESTOLOTE / @V_VRFATOCONV;
          END;

          IF (@V_VRFATOCONV = 1) BEGIN
             SET @V_QTINVROTA = @C_VERIFESTOQUELOTE_QTINVELOTE;
          END
          ELSE BEGIN
             SET @V_QTINVROTA = @C_VERIFESTOQUELOTE_QTINVELOTE * @V_VRFATOCONV;
          END;

          IF (@V_IDORDAJUINVE = 'U') BEGIN
             SET @V_DTPOSESTDIA = @C_VERIFESTOQUELOTE_DTINVELOTE;
          END
          ELSE BEGIN
             SET @V_DTPOSESTDIA = @C_VERIFESTOQUELOTE_DTINVELOTE - 1;
          END;

          SET @V_TIPOMOV = '0';

          IF ((@V_ALMOXARIF <> @C_VERIFESTOQUELOTE_CDALMOXARIFE) OR (@V_LOCALEST <> @C_VERIFESTOQUELOTE_CDLOCALESTOQ) OR (@V_NRSEQIMP = 9999)) BEGIN
             SET @V_ALMOXARIF = @C_VERIFESTOQUELOTE_CDALMOXARIFE;
             SET @V_LOCALEST = @C_VERIFESTOQUELOTE_CDLOCALESTOQ;

             IF (@V_NRIMPLANTA IS NOT NULL) BEGIN
                IF (@P_EVOLEST = 'S') BEGIN
                   DECLARE C_MOVILOTE CURSOR FOR
                   SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
                     FROM MOVILOTE
                    WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRIMPLANTA;

                   OPEN C_MOVILOTE;
                   FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                   @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;

                   WHILE (@@FETCH_STATUS = 0) BEGIN
                      UPDATE ITLANCTOEST
                         SET IDEVOLESTOQ = 'S'
                       WHERE CDFILIAL = @P_CDFILIAL
                         AND NRLANCESTQ = @V_NRIMPLANTA
                         AND CDPRODUTO = @V_MCDPRODUTO
                         AND CDALMOXARIFE = @V_MCDALMOXARIFE
                         AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                         AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                         AND NRSUBLOTE = @V_MNRSUBLOTE;

                      FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                                      @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
                   END;
                   CLOSE C_MOVILOTE;
                   DEALLOCATE C_MOVILOTE;

                   EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRIMPLANTA;
                END
                ELSE BEGIN
                   UPDATE ITLANCTOEST
                      SET IDEVOLESTOQ = 'N'
                    WHERE CDFILIAL = @P_CDFILIAL
                      AND NRLANCESTQ = @V_NRIMPLANTA;
                END;
             END;

             SET @V_NOVOCODIGO = 'LANCTOEST' + @P_CDFILIAL;
             EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_SEQUENCIAL OUTPUT, @P_QTDE = 1;
             SET @V_NRIMPLANTA = SUBSTRING(@V_SEQUENCIAL, 11, 20);

             SET @V_DESCALMOX = 'Implantao para Inventrio Rotativo';
             IF (@V_IDUTILALMOX = 'S') BEGIN
                SET @V_DESCALMOX = @V_DESCALMOX + ' - Almox. ' + @C_VERIFESTOQUELOTE_CDALMOXARIFE;
                  IF (@V_IDUTILLCESTQ = 'S') BEGIN
                     SET @V_DESCALMOX = @V_DESCALMOX + ' Local. ' + @C_VERIFESTOQUELOTE_CDLOCALESTOQ;
                  END;
             END;

             /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - IMPLANTAO */
             INSERT INTO LANCTOESTOQ (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, CDFILIMOVI, CDOPERADOR, DSLANCESTQ)
             VALUES (@C_VERIFESTOQUELOTE_CDFILIAL, @V_NRIMPLANTA, @V_TIPOMOV, @V_INVLTDTINVELOTE, @P_CDFILIMOVI, @P_CDOPERADOR, @V_DESCALMOX);

             SET @V_NRSEQIMP = 0;
          END;

          SET @V_NRSEQIMP = @V_NRSEQIMP + 1;

          /* INSERE O ITEM DO LANAMENTO DE MOVIMENTAO DE ESTOQUE - IMPLANTAO */
          INSERT INTO ITLANCTOEST
          (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO, QTLANCTOEST, QTTOTLANCTO,
          CDPRODMOVI, IDEVOLESTOQ, CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,
          NRSUBLOTE, IDTIPOMOVI, VRLANCTOEST, VRLANCTOBRUT, DTLANCMOVI, VRUNILANCTO,
          VRTOTLANCTO, IDORDEMCLC)
          VALUES
          (@C_VERIFESTOQUELOTE_CDFILIAL, @V_NRIMPLANTA, RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR, @V_NRSEQIMP),4), @V_INVLTCDPRODUTO, @V_QTINVROTA, @C_VERIFESTOQUELOTE_QTINVELOTE,
          @V_CDPRODESTO, 'N', @P_CDFILIMOVI, @C_VERIFESTOQUELOTE_CDALMOXARIFE, @C_VERIFESTOQUELOTE_CDLOCALESTOQ, @C_VERIFESTOQUELOTE_NRLOTEESTQ, @C_VERIFESTOQUELOTE_NRSUBLOTE, @V_TIPOMOV, @V_CUSTOPROD,
          @V_CUSTOPROD, @V_INVLTDTINVELOTE, (@V_CUSTOPROD * @V_VRFATOCONV), (@V_CUSTOPROD * @C_VERIFESTOQUELOTE_QTINVELOTE), @V_IDORDEMCLC);

          /* ATUALIZA O INVENTRIO DO PRODUTO */
          UPDATE INVEROTALOTE
             SET IDINVLOTEOK = 'S'
           WHERE CDFILIAL = @C_VERIFESTOQUELOTE_CDFILIAL
             AND DTINVELOTE = @V_INVLTDTINVELOTE
             AND CDALMOXARIFE = @C_VERIFESTOQUELOTE_CDALMOXARIFE
             AND CDLOCALESTOQ = @C_VERIFESTOQUELOTE_CDLOCALESTOQ
             AND CDPRODUTO = @V_INVLTCDPRODUTO
             AND NRLOTEESTQ = @C_VERIFESTOQUELOTE_NRLOTEESTQ
             AND NRSUBLOTE = @C_VERIFESTOQUELOTE_NRSUBLOTE;


          FETCH NEXT FROM C_VERIFESTOQUELOTE INTO @C_VERIFESTOQUELOTE_CDFILIAL,
                                                 @C_VERIFESTOQUELOTE_DTINVELOTE,
                                                 @C_VERIFESTOQUELOTE_CDALMOXARIFE,
                                                 @C_VERIFESTOQUELOTE_CDLOCALESTOQ,
                                                 @C_VERIFESTOQUELOTE_CDPRODUTO,
                                                 @C_VERIFESTOQUELOTE_NRLOTEESTQ,
                                                 @C_VERIFESTOQUELOTE_NRSUBLOTE,
                                                 @C_VERIFESTOQUELOTE_QTINVELOTE,
                                                 @C_VERIFESTOQUELOTE_QTESTOLOTE,
                                                 @C_VERIFESTOQUELOTE_NMPRODUTO,
                                                 @C_VERIFESTOQUELOTE_CDARVPROD;

       END;
       CLOSE C_VERIFESTOQUELOTE;
       DEALLOCATE C_VERIFESTOQUELOTE;

       IF (@V_NRIMPLANTA IS NOT NULL) BEGIN
          IF (@P_EVOLEST = 'S') BEGIN
             DECLARE C_MOVILOTE CURSOR FOR
             SELECT CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO
               FROM MOVILOTE
              WHERE NRMOVILOTE = @P_CDFILIAL + @V_NRIMPLANTA;

             OPEN C_MOVILOTE;
             FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ,
                                             @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;

             WHILE (@@FETCH_STATUS = 0) BEGIN
                UPDATE ITLANCTOEST
                   SET IDEVOLESTOQ = 'S'
                 WHERE CDFILIAL = @P_CDFILIAL
                   AND NRLANCESTQ = @V_NRIMPLANTA
                   AND CDPRODUTO = @V_MCDPRODUTO
                   AND CDALMOXARIFE = @V_MCDALMOXARIFE
                   AND CDLOCALESTOQ = @V_MCDLOCALESTOQ
                   AND NRLOTEESTQ  = @V_MNRLOTEESTQ
                   AND NRSUBLOTE = @V_MNRSUBLOTE;
                
                FETCH NEXT FROM C_MOVILOTE INTO @V_MCDFILIAL, @V_MCDALMOXARIFE, @V_MCDLOCALESTOQ, 
                                                @V_MNRLOTEESTQ, @V_MNRSUBLOTE, @V_MCDPRODUTO;
             END;
             CLOSE C_MOVILOTE;
             DEALLOCATE C_MOVILOTE;

             EXEC ATUALIZA_ESTOQUE @P_CDFILIMOVI, @V_DTPOSESTDIA, @P_DATAPROC, @P_CDFILIAL, @V_NRIMPLANTA;
          END
          ELSE BEGIN
             UPDATE ITLANCTOEST
                SET IDEVOLESTOQ = 'N'
              WHERE CDFILIAL = @P_CDFILIAL
                AND NRLANCESTQ = @V_NRIMPLANTA;
          END;
       END;
      /* FIM */
   END;
   COMMIT;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_INVENTARIO_ESTOQUE','6.05.XXX';
GO
