/* Sistemas Integrados TEKNISA

Nome: 5015_FISFUNS_CTBL_CMV.SQL

Descrio:
Funo para retornar a conta contabil CMV.

P_CDPRODUTO       - Cdigo do produto.

Criao:
08/08/2008 - Leonardo Bispo de Souza

*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CTBL_CMV'  AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CTBL_CMV
GO

CREATE FUNCTION CTBL_CMV(
   @P_CDPRODUTO  VARCHAR(10)) RETURNS VARCHAR(20)
AS
BEGIN
   DECLARE @V_CDCTBLPRACPR   VARCHAR(20);
   DECLARE @V_CDARVPROD   VARCHAR(20);

   SET @V_CDCTBLPRACPR = NULL;
   SET @V_CDARVPROD = NULL;

   SELECT @V_CDARVPROD = CDARVPROD 
   FROM PRODUTO
   WHERE CDPRODUTO = @P_CDPRODUTO;

      SELECT @V_CDCTBLPRACPR = PR.CDCTBLPRACPR
        FROM PRODUTO PR,
             (SELECT MAX(CDARVPROD) AS CDARVPROD
                FROM PRODUTO C
               WHERE (CHARINDEX(RTRIM(C.CDARVPROD),@V_CDARVPROD) = 1)
                 AND NOT CDCTBLPRACPR IS NULL) P
       WHERE PR.CDARVPROD = P.CDARVPROD;

   RETURN(@V_CDCTBLPRACPR);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CTBL_CMV','5.05.000';
GO
